--
-- sql/range.generated.sql
--
CREATE SCHEMA IF NOT EXISTS "toolkit_experimental";
        CREATE SCHEMA IF NOT EXISTS toolkit_experimental;
    
CREATE OR REPLACE FUNCTION toolkit_experimental.time_bucket_range( bucket_width interval, ts timestamptz)
RETURNS tstzrange as $$
SELECT tstzrange(time_bucket(bucket_width, ts), time_bucket(bucket_width, ts + bucket_width), '[)');
$$
LANGUAGE SQL IMMUTABLE PARALLEL SAFE;



--
-- sql/accessors.generated.sql
--
CREATE TYPE toolkit_experimental.accessorapproxrank;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorapproxrank_in(cstring) RETURNS toolkit_experimental.accessorapproxrank IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorapproxrank_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorapproxrank_out(toolkit_experimental.accessorapproxrank) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorapproxrank_out_wrapper';
CREATE TYPE toolkit_experimental.accessorapproxrank (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorapproxrank_in,
                                OUTPUT = toolkit_experimental.accessorapproxrank_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorapproxpercentile;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorapproxpercentile_in(cstring) RETURNS toolkit_experimental.accessorapproxpercentile IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorapproxpercentile_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorapproxpercentile_out(toolkit_experimental.accessorapproxpercentile) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorapproxpercentile_out_wrapper';
CREATE TYPE toolkit_experimental.accessorapproxpercentile (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorapproxpercentile_in,
                                OUTPUT = toolkit_experimental.accessorapproxpercentile_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessornumvals;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumvals_in(cstring) RETURNS toolkit_experimental.accessornumvals IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumvals_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumvals_out(toolkit_experimental.accessornumvals) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumvals_out_wrapper';
CREATE TYPE toolkit_experimental.accessornumvals (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessornumvals_in,
                                OUTPUT = toolkit_experimental.accessornumvals_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessormean;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessormean_in(cstring) RETURNS toolkit_experimental.accessormean IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessormean_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessormean_out(toolkit_experimental.accessormean) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessormean_out_wrapper';
CREATE TYPE toolkit_experimental.accessormean (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessormean_in,
                                OUTPUT = toolkit_experimental.accessormean_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorerror;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorerror_in(cstring) RETURNS toolkit_experimental.accessorerror IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorerror_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorerror_out(toolkit_experimental.accessorerror) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorerror_out_wrapper';
CREATE TYPE toolkit_experimental.accessorerror (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorerror_in,
                                OUTPUT = toolkit_experimental.accessorerror_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessormin;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessormin_in(cstring) RETURNS toolkit_experimental.accessormin IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessormin_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessormin_out(toolkit_experimental.accessormin) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessormin_out_wrapper';
CREATE TYPE toolkit_experimental.accessormin (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessormin_in,
                                OUTPUT = toolkit_experimental.accessormin_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessormax;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessormax_in(cstring) RETURNS toolkit_experimental.accessormax IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessormax_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessormax_out(toolkit_experimental.accessormax) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessormax_out_wrapper';
CREATE TYPE toolkit_experimental.accessormax (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessormax_in,
                                OUTPUT = toolkit_experimental.accessormax_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessoraverage;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessoraverage_in(cstring) RETURNS toolkit_experimental.accessoraverage IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessoraverage_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessoraverage_out(toolkit_experimental.accessoraverage) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessoraverage_out_wrapper';
CREATE TYPE toolkit_experimental.accessoraverage (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessoraverage_in,
                                OUTPUT = toolkit_experimental.accessoraverage_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessoraveragex;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessoraveragex_in(cstring) RETURNS toolkit_experimental.accessoraveragex IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessoraveragex_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessoraveragex_out(toolkit_experimental.accessoraveragex) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessoraveragex_out_wrapper';
CREATE TYPE toolkit_experimental.accessoraveragex (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessoraveragex_in,
                                OUTPUT = toolkit_experimental.accessoraveragex_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessoraveragey;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessoraveragey_in(cstring) RETURNS toolkit_experimental.accessoraveragey IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessoraveragey_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessoraveragey_out(toolkit_experimental.accessoraveragey) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessoraveragey_out_wrapper';
CREATE TYPE toolkit_experimental.accessoraveragey (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessoraveragey_in,
                                OUTPUT = toolkit_experimental.accessoraveragey_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorsum;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorsum_in(cstring) RETURNS toolkit_experimental.accessorsum IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorsum_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorsum_out(toolkit_experimental.accessorsum) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorsum_out_wrapper';
CREATE TYPE toolkit_experimental.accessorsum (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorsum_in,
                                OUTPUT = toolkit_experimental.accessorsum_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorsumx;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorsumx_in(cstring) RETURNS toolkit_experimental.accessorsumx IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorsumx_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorsumx_out(toolkit_experimental.accessorsumx) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorsumx_out_wrapper';
CREATE TYPE toolkit_experimental.accessorsumx (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorsumx_in,
                                OUTPUT = toolkit_experimental.accessorsumx_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorsumy;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorsumy_in(cstring) RETURNS toolkit_experimental.accessorsumy IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorsumy_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorsumy_out(toolkit_experimental.accessorsumy) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorsumy_out_wrapper';
CREATE TYPE toolkit_experimental.accessorsumy (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorsumy_in,
                                OUTPUT = toolkit_experimental.accessorsumy_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorslope;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorslope_in(cstring) RETURNS toolkit_experimental.accessorslope IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorslope_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorslope_out(toolkit_experimental.accessorslope) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorslope_out_wrapper';
CREATE TYPE toolkit_experimental.accessorslope (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorslope_in,
                                OUTPUT = toolkit_experimental.accessorslope_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorstddev;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstddev_in(cstring) RETURNS toolkit_experimental.accessorstddev IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstddev_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstddev_out(toolkit_experimental.accessorstddev) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstddev_out_wrapper';
CREATE TYPE toolkit_experimental.accessorstddev (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorstddev_in,
                                OUTPUT = toolkit_experimental.accessorstddev_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorstddevx;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstddevx_in(cstring) RETURNS toolkit_experimental.accessorstddevx IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstddevx_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstddevx_out(toolkit_experimental.accessorstddevx) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstddevx_out_wrapper';
CREATE TYPE toolkit_experimental.accessorstddevx (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorstddevx_in,
                                OUTPUT = toolkit_experimental.accessorstddevx_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorstddevy;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstddevy_in(cstring) RETURNS toolkit_experimental.accessorstddevy IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstddevy_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstddevy_out(toolkit_experimental.accessorstddevy) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstddevy_out_wrapper';
CREATE TYPE toolkit_experimental.accessorstddevy (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorstddevy_in,
                                OUTPUT = toolkit_experimental.accessorstddevy_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorvariance;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorvariance_in(cstring) RETURNS toolkit_experimental.accessorvariance IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorvariance_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorvariance_out(toolkit_experimental.accessorvariance) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorvariance_out_wrapper';
CREATE TYPE toolkit_experimental.accessorvariance (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorvariance_in,
                                OUTPUT = toolkit_experimental.accessorvariance_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorvariancex;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorvariancex_in(cstring) RETURNS toolkit_experimental.accessorvariancex IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorvariancex_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorvariancex_out(toolkit_experimental.accessorvariancex) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorvariancex_out_wrapper';
CREATE TYPE toolkit_experimental.accessorvariancex (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorvariancex_in,
                                OUTPUT = toolkit_experimental.accessorvariancex_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorvariancey;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorvariancey_in(cstring) RETURNS toolkit_experimental.accessorvariancey IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorvariancey_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorvariancey_out(toolkit_experimental.accessorvariancey) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorvariancey_out_wrapper';
CREATE TYPE toolkit_experimental.accessorvariancey (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorvariancey_in,
                                OUTPUT = toolkit_experimental.accessorvariancey_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorskewness;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorskewness_in(cstring) RETURNS toolkit_experimental.accessorskewness IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorskewness_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorskewness_out(toolkit_experimental.accessorskewness) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorskewness_out_wrapper';
CREATE TYPE toolkit_experimental.accessorskewness (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorskewness_in,
                                OUTPUT = toolkit_experimental.accessorskewness_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorskewnessx;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorskewnessx_in(cstring) RETURNS toolkit_experimental.accessorskewnessx IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorskewnessx_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorskewnessx_out(toolkit_experimental.accessorskewnessx) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorskewnessx_out_wrapper';
CREATE TYPE toolkit_experimental.accessorskewnessx (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorskewnessx_in,
                                OUTPUT = toolkit_experimental.accessorskewnessx_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorskewnessy;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorskewnessy_in(cstring) RETURNS toolkit_experimental.accessorskewnessy IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorskewnessy_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorskewnessy_out(toolkit_experimental.accessorskewnessy) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorskewnessy_out_wrapper';
CREATE TYPE toolkit_experimental.accessorskewnessy (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorskewnessy_in,
                                OUTPUT = toolkit_experimental.accessorskewnessy_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorkurtosis;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorkurtosis_in(cstring) RETURNS toolkit_experimental.accessorkurtosis IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorkurtosis_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorkurtosis_out(toolkit_experimental.accessorkurtosis) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorkurtosis_out_wrapper';
CREATE TYPE toolkit_experimental.accessorkurtosis (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorkurtosis_in,
                                OUTPUT = toolkit_experimental.accessorkurtosis_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorkurtosisx;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorkurtosisx_in(cstring) RETURNS toolkit_experimental.accessorkurtosisx IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorkurtosisx_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorkurtosisx_out(toolkit_experimental.accessorkurtosisx) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorkurtosisx_out_wrapper';
CREATE TYPE toolkit_experimental.accessorkurtosisx (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorkurtosisx_in,
                                OUTPUT = toolkit_experimental.accessorkurtosisx_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorkurtosisy;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorkurtosisy_in(cstring) RETURNS toolkit_experimental.accessorkurtosisy IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorkurtosisy_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorkurtosisy_out(toolkit_experimental.accessorkurtosisy) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorkurtosisy_out_wrapper';
CREATE TYPE toolkit_experimental.accessorkurtosisy (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorkurtosisy_in,
                                OUTPUT = toolkit_experimental.accessorkurtosisy_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorcorr;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorcorr_in(cstring) RETURNS toolkit_experimental.accessorcorr IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorcorr_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorcorr_out(toolkit_experimental.accessorcorr) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorcorr_out_wrapper';
CREATE TYPE toolkit_experimental.accessorcorr (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorcorr_in,
                                OUTPUT = toolkit_experimental.accessorcorr_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorintercept;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorintercept_in(cstring) RETURNS toolkit_experimental.accessorintercept IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorintercept_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorintercept_out(toolkit_experimental.accessorintercept) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorintercept_out_wrapper';
CREATE TYPE toolkit_experimental.accessorintercept (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorintercept_in,
                                OUTPUT = toolkit_experimental.accessorintercept_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorxintercept;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorxintercept_in(cstring) RETURNS toolkit_experimental.accessorxintercept IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorxintercept_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorxintercept_out(toolkit_experimental.accessorxintercept) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorxintercept_out_wrapper';
CREATE TYPE toolkit_experimental.accessorxintercept (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorxintercept_in,
                                OUTPUT = toolkit_experimental.accessorxintercept_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessordeterminationcoeff;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessordeterminationcoeff_in(cstring) RETURNS toolkit_experimental.accessordeterminationcoeff IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessordeterminationcoeff_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessordeterminationcoeff_out(toolkit_experimental.accessordeterminationcoeff) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessordeterminationcoeff_out_wrapper';
CREATE TYPE toolkit_experimental.accessordeterminationcoeff (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessordeterminationcoeff_in,
                                OUTPUT = toolkit_experimental.accessordeterminationcoeff_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorcovar;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorcovar_in(cstring) RETURNS toolkit_experimental.accessorcovar IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorcovar_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorcovar_out(toolkit_experimental.accessorcovar) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorcovar_out_wrapper';
CREATE TYPE toolkit_experimental.accessorcovar (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorcovar_in,
                                OUTPUT = toolkit_experimental.accessorcovar_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessordistinctcount;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessordistinctcount_in(cstring) RETURNS toolkit_experimental.accessordistinctcount IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessordistinctcount_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessordistinctcount_out(toolkit_experimental.accessordistinctcount) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessordistinctcount_out_wrapper';
CREATE TYPE toolkit_experimental.accessordistinctcount (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessordistinctcount_in,
                                OUTPUT = toolkit_experimental.accessordistinctcount_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorstderror;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstderror_in(cstring) RETURNS toolkit_experimental.accessorstderror IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstderror_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorstderror_out(toolkit_experimental.accessorstderror) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorstderror_out_wrapper';
CREATE TYPE toolkit_experimental.accessorstderror (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorstderror_in,
                                OUTPUT = toolkit_experimental.accessorstderror_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessordelta;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessordelta_in(cstring) RETURNS toolkit_experimental.accessordelta IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessordelta_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessordelta_out(toolkit_experimental.accessordelta) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessordelta_out_wrapper';
CREATE TYPE toolkit_experimental.accessordelta (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessordelta_in,
                                OUTPUT = toolkit_experimental.accessordelta_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessortimedelta;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessortimedelta_in(cstring) RETURNS toolkit_experimental.accessortimedelta IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessortimedelta_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessortimedelta_out(toolkit_experimental.accessortimedelta) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessortimedelta_out_wrapper';
CREATE TYPE toolkit_experimental.accessortimedelta (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessortimedelta_in,
                                OUTPUT = toolkit_experimental.accessortimedelta_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorrate;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorrate_in(cstring) RETURNS toolkit_experimental.accessorrate IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorrate_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorrate_out(toolkit_experimental.accessorrate) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorrate_out_wrapper';
CREATE TYPE toolkit_experimental.accessorrate (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorrate_in,
                                OUTPUT = toolkit_experimental.accessorrate_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorirateleft;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorirateleft_in(cstring) RETURNS toolkit_experimental.accessorirateleft IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorirateleft_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorirateleft_out(toolkit_experimental.accessorirateleft) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorirateleft_out_wrapper';
CREATE TYPE toolkit_experimental.accessorirateleft (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorirateleft_in,
                                OUTPUT = toolkit_experimental.accessorirateleft_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorirateright;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorirateright_in(cstring) RETURNS toolkit_experimental.accessorirateright IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorirateright_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorirateright_out(toolkit_experimental.accessorirateright) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorirateright_out_wrapper';
CREATE TYPE toolkit_experimental.accessorirateright (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorirateright_in,
                                OUTPUT = toolkit_experimental.accessorirateright_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorideltaleft;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorideltaleft_in(cstring) RETURNS toolkit_experimental.accessorideltaleft IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorideltaleft_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorideltaleft_out(toolkit_experimental.accessorideltaleft) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorideltaleft_out_wrapper';
CREATE TYPE toolkit_experimental.accessorideltaleft (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorideltaleft_in,
                                OUTPUT = toolkit_experimental.accessorideltaleft_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorideltaright;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorideltaright_in(cstring) RETURNS toolkit_experimental.accessorideltaright IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorideltaright_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorideltaright_out(toolkit_experimental.accessorideltaright) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorideltaright_out_wrapper';
CREATE TYPE toolkit_experimental.accessorideltaright (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorideltaright_in,
                                OUTPUT = toolkit_experimental.accessorideltaright_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessornumelements;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumelements_in(cstring) RETURNS toolkit_experimental.accessornumelements IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumelements_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumelements_out(toolkit_experimental.accessornumelements) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumelements_out_wrapper';
CREATE TYPE toolkit_experimental.accessornumelements (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessornumelements_in,
                                OUTPUT = toolkit_experimental.accessornumelements_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessornumchanges;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumchanges_in(cstring) RETURNS toolkit_experimental.accessornumchanges IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumchanges_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumchanges_out(toolkit_experimental.accessornumchanges) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumchanges_out_wrapper';
CREATE TYPE toolkit_experimental.accessornumchanges (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessornumchanges_in,
                                OUTPUT = toolkit_experimental.accessornumchanges_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessornumresets;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumresets_in(cstring) RETURNS toolkit_experimental.accessornumresets IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumresets_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessornumresets_out(toolkit_experimental.accessornumresets) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessornumresets_out_wrapper';
CREATE TYPE toolkit_experimental.accessornumresets (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessornumresets_in,
                                OUTPUT = toolkit_experimental.accessornumresets_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorzerotime;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorzerotime_in(cstring) RETURNS toolkit_experimental.accessorzerotime IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorzerotime_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorzerotime_out(toolkit_experimental.accessorzerotime) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorzerotime_out_wrapper';
CREATE TYPE toolkit_experimental.accessorzerotime (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorzerotime_in,
                                OUTPUT = toolkit_experimental.accessorzerotime_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorextrapolateddelta;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorextrapolateddelta_in(cstring) RETURNS toolkit_experimental.accessorextrapolateddelta IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorextrapolateddelta_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorextrapolateddelta_out(toolkit_experimental.accessorextrapolateddelta) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorextrapolateddelta_out_wrapper';
CREATE TYPE toolkit_experimental.accessorextrapolateddelta (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorextrapolateddelta_in,
                                OUTPUT = toolkit_experimental.accessorextrapolateddelta_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorextrapolatedrate;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorextrapolatedrate_in(cstring) RETURNS toolkit_experimental.accessorextrapolatedrate IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorextrapolatedrate_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorextrapolatedrate_out(toolkit_experimental.accessorextrapolatedrate) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorextrapolatedrate_out_wrapper';
CREATE TYPE toolkit_experimental.accessorextrapolatedrate (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorextrapolatedrate_in,
                                OUTPUT = toolkit_experimental.accessorextrapolatedrate_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.accessorwithbounds;
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorwithbounds_in(cstring) RETURNS toolkit_experimental.accessorwithbounds IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorwithbounds_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.accessorwithbounds_out(toolkit_experimental.accessorwithbounds) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'accessorwithbounds_out_wrapper';
CREATE TYPE toolkit_experimental.accessorwithbounds (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.accessorwithbounds_in,
                                OUTPUT = toolkit_experimental.accessorwithbounds_out,
                                STORAGE = extended
                            );
-- ./src/accessors.rs:78:0
CREATE OR REPLACE FUNCTION toolkit_experimental.approx_percentile("percentile" double precision) RETURNS toolkit_experimental.AccessorApproxPercentile IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_approx_percentile_wrapper';
-- ./src/accessors.rs:98:0
CREATE OR REPLACE FUNCTION toolkit_experimental.approx_percentile_rank("value" double precision) RETURNS toolkit_experimental.AccessorApproxRank IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_approx_rank_wrapper';
-- ./src/accessors.rs:117:0
CREATE OR REPLACE FUNCTION toolkit_experimental.num_vals() RETURNS toolkit_experimental.AccessorNumVals IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_num_vals_wrapper';
-- ./src/accessors.rs:134:0
CREATE OR REPLACE FUNCTION toolkit_experimental.mean() RETURNS toolkit_experimental.AccessorMean IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_mean_wrapper';
-- ./src/accessors.rs:151:0
CREATE OR REPLACE FUNCTION toolkit_experimental.error() RETURNS toolkit_experimental.AccessorError IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_error_wrapper';
-- ./src/accessors.rs:168:0
CREATE OR REPLACE FUNCTION toolkit_experimental.min_val() RETURNS toolkit_experimental.AccessorMin IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_min_wrapper';
-- ./src/accessors.rs:185:0
CREATE OR REPLACE FUNCTION toolkit_experimental.max_val() RETURNS toolkit_experimental.AccessorMax IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_max_wrapper';
-- ./src/accessors.rs:202:0
CREATE OR REPLACE FUNCTION toolkit_experimental.average() RETURNS toolkit_experimental.AccessorAverage IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_average_wrapper';
-- ./src/accessors.rs:220:0
CREATE OR REPLACE FUNCTION toolkit_experimental.average_x() RETURNS toolkit_experimental.AccessorAverageX IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_average_x_wrapper';
-- ./src/accessors.rs:238:0
CREATE OR REPLACE FUNCTION toolkit_experimental.average_y() RETURNS toolkit_experimental.AccessorAverageY IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_average_y_wrapper';
-- ./src/accessors.rs:256:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sum() RETURNS toolkit_experimental.AccessorSum IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_sum_wrapper';
-- ./src/accessors.rs:274:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sum_x() RETURNS toolkit_experimental.AccessorSumX IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_sum_x_wrapper';
-- ./src/accessors.rs:292:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sum_y() RETURNS toolkit_experimental.AccessorSumY IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_sum_y_wrapper';
-- ./src/accessors.rs:310:0
CREATE OR REPLACE FUNCTION toolkit_experimental.slope() RETURNS toolkit_experimental.AccessorSlope IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_slope_wrapper';
-- ./src/accessors.rs:331:0
CREATE OR REPLACE FUNCTION toolkit_experimental.stddev("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorStdDev IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_stddev_wrapper';
-- ./src/accessors.rs:358:0
CREATE OR REPLACE FUNCTION toolkit_experimental.stddev_x("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorStdDevX IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_stddev_x_wrapper';
-- ./src/accessors.rs:385:0
CREATE OR REPLACE FUNCTION toolkit_experimental.stddev_y("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorStdDevY IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_stddev_y_wrapper';
-- ./src/accessors.rs:412:0
CREATE OR REPLACE FUNCTION toolkit_experimental.variance("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorVariance IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_variance_wrapper';
-- ./src/accessors.rs:439:0
CREATE OR REPLACE FUNCTION toolkit_experimental.variance_x("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorVarianceX IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_variance_x_wrapper';
-- ./src/accessors.rs:465:0
CREATE OR REPLACE FUNCTION toolkit_experimental.variance_y("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorVarianceY IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_variance_y_wrapper';
-- ./src/accessors.rs:491:0
CREATE OR REPLACE FUNCTION toolkit_experimental.skewness("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorSkewness IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_skewness_wrapper';
-- ./src/accessors.rs:517:0
CREATE OR REPLACE FUNCTION toolkit_experimental.skewness_x("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorSkewnessX IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_skewness_x_wrapper';
-- ./src/accessors.rs:543:0
CREATE OR REPLACE FUNCTION toolkit_experimental.skewness_y("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorSkewnessY IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_skewness_y_wrapper';
-- ./src/accessors.rs:569:0
CREATE OR REPLACE FUNCTION toolkit_experimental.kurtosis("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorKurtosis IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_kurtosis_wrapper';
-- ./src/accessors.rs:595:0
CREATE OR REPLACE FUNCTION toolkit_experimental.kurtosis_x("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorKurtosisX IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_kurtosis_x_wrapper';
-- ./src/accessors.rs:621:0
CREATE OR REPLACE FUNCTION toolkit_experimental.kurtosis_y("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorKurtosisY IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_kurtosis_y_wrapper';
-- ./src/accessors.rs:645:0
CREATE OR REPLACE FUNCTION toolkit_experimental.corr() RETURNS toolkit_experimental.AccessorCorr IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_corr_wrapper';
-- ./src/accessors.rs:663:0
CREATE OR REPLACE FUNCTION toolkit_experimental.intercept() RETURNS toolkit_experimental.AccessorIntercept IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_intercept_wrapper';
-- ./src/accessors.rs:681:0
CREATE OR REPLACE FUNCTION toolkit_experimental.x_intercept() RETURNS toolkit_experimental.AccessorXIntercept IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_x_intercept_wrapper';
-- ./src/accessors.rs:699:0
CREATE OR REPLACE FUNCTION toolkit_experimental.determination_coeff() RETURNS toolkit_experimental.AccessorDeterminationCoeff IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_determination_coeff_wrapper';
-- ./src/accessors.rs:720:0
CREATE OR REPLACE FUNCTION toolkit_experimental.covariance("method" text DEFAULT 'sample') RETURNS toolkit_experimental.AccessorCovar IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_covar_wrapper';
-- ./src/accessors.rs:744:0
CREATE OR REPLACE FUNCTION toolkit_experimental.distinct_count() RETURNS toolkit_experimental.AccessorDistinctCount IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_distinct_count_wrapper';
-- ./src/accessors.rs:762:0
CREATE OR REPLACE FUNCTION toolkit_experimental.stderror() RETURNS toolkit_experimental.AccessorStdError IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_stderror_wrapper';
-- ./src/accessors.rs:780:0
CREATE OR REPLACE FUNCTION toolkit_experimental.delta() RETURNS toolkit_experimental.AccessorDelta IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_delta_wrapper';
-- ./src/accessors.rs:798:0
CREATE OR REPLACE FUNCTION toolkit_experimental.time_delta() RETURNS toolkit_experimental.AccessorTimeDelta IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_time_delta_wrapper';
-- ./src/accessors.rs:816:0
CREATE OR REPLACE FUNCTION toolkit_experimental.rate() RETURNS toolkit_experimental.AccessorRate IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_rate_wrapper';
-- ./src/accessors.rs:834:0
CREATE OR REPLACE FUNCTION toolkit_experimental.irate_left() RETURNS toolkit_experimental.AccessorIRateLeft IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_irate_left_wrapper';
-- ./src/accessors.rs:852:0
CREATE OR REPLACE FUNCTION toolkit_experimental.irate_right() RETURNS toolkit_experimental.AccessorIRateRight IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_irate_right_wrapper';
-- ./src/accessors.rs:870:0
CREATE OR REPLACE FUNCTION toolkit_experimental.idelta_left() RETURNS toolkit_experimental.AccessorIDeltaLeft IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_idelta_left_wrapper';
-- ./src/accessors.rs:888:0
CREATE OR REPLACE FUNCTION toolkit_experimental.idelta_right() RETURNS toolkit_experimental.AccessorIDeltaRight IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_idelta_right_wrapper';
-- ./src/accessors.rs:906:0
CREATE OR REPLACE FUNCTION toolkit_experimental.num_elements() RETURNS toolkit_experimental.AccessorNumElements IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_num_elements_wrapper';
-- ./src/accessors.rs:924:0
CREATE OR REPLACE FUNCTION toolkit_experimental.num_changes() RETURNS toolkit_experimental.AccessorNumChanges IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_num_changes_wrapper';
-- ./src/accessors.rs:942:0
CREATE OR REPLACE FUNCTION toolkit_experimental.num_resets() RETURNS toolkit_experimental.AccessorNumResets IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_num_resets_wrapper';
-- ./src/accessors.rs:960:0
CREATE OR REPLACE FUNCTION toolkit_experimental.counter_zero_time() RETURNS toolkit_experimental.AccessorZeroTime IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_zero_time_wrapper';
-- ./src/accessors.rs:981:0
CREATE OR REPLACE FUNCTION toolkit_experimental.extrapolated_delta("method" text) RETURNS toolkit_experimental.AccessorExtrapolatedDelta IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_extrapolated_delta_wrapper';
-- ./src/accessors.rs:1008:0
CREATE OR REPLACE FUNCTION toolkit_experimental.extrapolated_rate("method" text) RETURNS toolkit_experimental.AccessorExtrapolatedRate IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_extrapolated_rate_wrapper';
-- ./src/accessors.rs:1040:0
CREATE OR REPLACE FUNCTION toolkit_experimental.with_bounds("bounds" tstzrange) RETURNS toolkit_experimental.AccessorWithBounds IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'accessor_with_bounds_wrapper';



--
-- sql/tdigest.generated.sql
--
CREATE TYPE tdigest;
CREATE OR REPLACE FUNCTION tdigest_in(cstring) RETURNS tdigest IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_in_wrapper';
CREATE OR REPLACE FUNCTION tdigest_out(tdigest) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_out_wrapper';
CREATE TYPE tdigest (
                                INTERNALLENGTH = variable,
                                INPUT = tdigest_in,
                                OUTPUT = tdigest_out,
                                STORAGE = extended
                            );
-- ./src/tdigest.rs:57:0
CREATE OR REPLACE FUNCTION "tdigest_trans"("state" internal, "size" int, "value" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_trans_wrapper';
-- ./src/tdigest.rs:85:0
CREATE OR REPLACE FUNCTION "tdigest_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_combine_wrapper';
-- ./src/tdigest.rs:121:0
CREATE OR REPLACE FUNCTION "tdigest_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_serialize_wrapper';
-- ./src/tdigest.rs:129:0
CREATE OR REPLACE FUNCTION "tdigest_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_deserialize_wrapper';
-- ./src/tdigest.rs:190:0
CREATE OR REPLACE FUNCTION "tdigest_final"("state" internal) RETURNS TDigest IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_final_wrapper';
CREATE AGGREGATE tdigest(size int, value DOUBLE PRECISION)
(
    sfunc = tdigest_trans,
    stype = internal,
    finalfunc = tdigest_final,
    combinefunc = tdigest_combine,
    serialfunc = tdigest_serialize,
    deserialfunc = tdigest_deserialize,
    parallel = safe
);
-- ./src/tdigest.rs:222:0
CREATE OR REPLACE FUNCTION "tdigest_compound_trans"("state" internal, "value" TDigest) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_compound_trans_wrapper';
-- ./src/tdigest.rs:244:0
CREATE OR REPLACE FUNCTION "tdigest_compound_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_compound_combine_wrapper';
-- ./src/tdigest.rs:267:0
CREATE OR REPLACE FUNCTION "tdigest_compound_final"("state" internal) RETURNS TDigest IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_compound_final_wrapper';
-- ./src/tdigest.rs:278:0
CREATE OR REPLACE FUNCTION "tdigest_compound_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_compound_serialize_wrapper';
-- ./src/tdigest.rs:286:0
CREATE OR REPLACE FUNCTION "tdigest_compound_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_compound_deserialize_wrapper';
CREATE AGGREGATE rollup(
    tdigest
) (
    sfunc = tdigest_compound_trans,
    stype = internal,
    finalfunc = tdigest_compound_final,
    combinefunc = tdigest_compound_combine,
    serialfunc = tdigest_compound_serialize,
    deserialfunc = tdigest_compound_deserialize,
    parallel = safe
);
-- ./src/tdigest.rs:311:0
CREATE OR REPLACE FUNCTION "arrow_tdigest_approx_percentile"("sketch" TDigest, "accessor" toolkit_experimental.AccessorApproxPercentile) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_tdigest_approx_percentile_wrapper';
-- ./src/tdigest.rs:321:0
CREATE OR REPLACE FUNCTION approx_percentile("quantile" double precision, "digest" TDigest) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_quantile_wrapper';
-- ./src/tdigest.rs:329:0
CREATE OR REPLACE FUNCTION "arrow_tdigest_approx_rank"("sketch" TDigest, "accessor" toolkit_experimental.AccessorApproxRank) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_tdigest_approx_rank_wrapper';
-- ./src/tdigest.rs:339:0
CREATE OR REPLACE FUNCTION approx_percentile_rank("value" double precision, "digest" TDigest) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_quantile_at_value_wrapper';
-- ./src/tdigest.rs:347:0
CREATE OR REPLACE FUNCTION "arrow_tdigest_num_vals"("sketch" TDigest, "accessor" toolkit_experimental.AccessorNumVals) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_tdigest_num_vals_wrapper';
-- ./src/tdigest.rs:358:0
CREATE OR REPLACE FUNCTION num_vals("digest" TDigest) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_count_wrapper';
-- ./src/tdigest.rs:365:0
CREATE OR REPLACE FUNCTION "arrow_tdigest_min"("sketch" TDigest, "accessor" toolkit_experimental.AccessorMin) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_tdigest_min_wrapper';
-- ./src/tdigest.rs:376:0
CREATE OR REPLACE FUNCTION min_val("digest" TDigest) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_min_wrapper';
-- ./src/tdigest.rs:384:0
CREATE OR REPLACE FUNCTION "arrow_tdigest_max"("sketch" TDigest, "accessor" toolkit_experimental.AccessorMax) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_tdigest_max_wrapper';
-- ./src/tdigest.rs:395:0
CREATE OR REPLACE FUNCTION max_val("digest" TDigest) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_max_wrapper';
-- ./src/tdigest.rs:402:0
CREATE OR REPLACE FUNCTION "arrow_tdigest_mean"("sketch" TDigest, "accessor" toolkit_experimental.AccessorMean) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_tdigest_mean_wrapper';
-- ./src/tdigest.rs:414:0
CREATE OR REPLACE FUNCTION mean("digest" TDigest) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'tdigest_mean_wrapper';
CREATE OPERATOR -> (
   PROCEDURE="arrow_tdigest_approx_percentile",
   LEFTARG=TDigest,
   RIGHTARG=toolkit_experimental.AccessorApproxPercentile
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_tdigest_approx_rank",
   LEFTARG=TDigest,
   RIGHTARG=toolkit_experimental.AccessorApproxRank
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_tdigest_num_vals",
   LEFTARG=TDigest,
   RIGHTARG=toolkit_experimental.AccessorNumVals
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_tdigest_min",
   LEFTARG=TDigest,
   RIGHTARG=toolkit_experimental.AccessorMin
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_tdigest_max",
   LEFTARG=TDigest,
   RIGHTARG=toolkit_experimental.AccessorMax
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_tdigest_mean",
   LEFTARG=TDigest,
   RIGHTARG=toolkit_experimental.AccessorMean
);



--
-- sql/hyperloglog.generated.sql
--
CREATE TYPE hyperloglog;
CREATE OR REPLACE FUNCTION hyperloglog_in(cstring) RETURNS hyperloglog IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_in_wrapper';
CREATE OR REPLACE FUNCTION hyperloglog_out(hyperloglog) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_out_wrapper';
CREATE TYPE hyperloglog (
                                INTERNALLENGTH = variable,
                                INPUT = hyperloglog_in,
                                OUTPUT = hyperloglog_out,
                                STORAGE = extended
                            );
-- ./src/hyperloglog.rs:34:0
CREATE OR REPLACE FUNCTION "hyperloglog_trans"("state" internal, "size" int, "value" anyelement) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_trans_wrapper';
-- ./src/hyperloglog.rs:70:0
CREATE OR REPLACE FUNCTION "hyperloglog_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_combine_wrapper';
-- ./src/hyperloglog.rs:93:0
CREATE OR REPLACE FUNCTION "hyperloglog_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_serialize_wrapper';
-- ./src/hyperloglog.rs:98:0
CREATE OR REPLACE FUNCTION "hyperloglog_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_deserialize_wrapper';
-- ./src/hyperloglog.rs:151:0
CREATE OR REPLACE FUNCTION "hyperloglog_final"("state" internal) RETURNS HyperLogLog IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_final_wrapper';
CREATE AGGREGATE hyperloglog(size int, value AnyElement)
(
    stype = internal,
    sfunc = hyperloglog_trans,
    finalfunc = hyperloglog_final,
    combinefunc = hyperloglog_combine,
    serialfunc = hyperloglog_serialize,
    deserialfunc = hyperloglog_deserialize,
    parallel = safe
);
-- ./src/hyperloglog.rs:183:0
CREATE OR REPLACE FUNCTION "hyperloglog_union"("state" internal, "other" HyperLogLog) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_union_wrapper';
CREATE AGGREGATE rollup(hyperloglog Hyperloglog)
(
    stype = internal,
    sfunc = hyperloglog_union,
    finalfunc = hyperloglog_final,
    combinefunc = hyperloglog_combine,
    serialfunc = hyperloglog_serialize,
    deserialfunc = hyperloglog_deserialize,
    parallel = safe
);
-- ./src/hyperloglog.rs:228:0
CREATE OR REPLACE FUNCTION "arrow_hyperloglog_count"("sketch" HyperLogLog, "accessor" toolkit_experimental.AccessorDistinctCount) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_hyperloglog_count_wrapper';
-- ./src/hyperloglog.rs:238:0
CREATE OR REPLACE FUNCTION distinct_count("hyperloglog" HyperLogLog) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_count_wrapper';
-- ./src/hyperloglog.rs:253:0
CREATE OR REPLACE FUNCTION "arrow_hyperloglog_error"("sketch" HyperLogLog, "accessor" toolkit_experimental.AccessorStdError) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_hyperloglog_error_wrapper';
-- ./src/hyperloglog.rs:263:0
CREATE OR REPLACE FUNCTION stderror("hyperloglog" HyperLogLog) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'hyperloglog_error_wrapper';
CREATE OPERATOR -> (
   PROCEDURE="arrow_hyperloglog_count",
   LEFTARG=HyperLogLog,
   RIGHTARG=toolkit_experimental.AccessorDistinctCount
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_hyperloglog_error",
   LEFTARG=HyperLogLog,
   RIGHTARG=toolkit_experimental.AccessorStdError
);



--
-- sql/uddsketch.generated.sql
--
CREATE TYPE uddsketch;
CREATE OR REPLACE FUNCTION uddsketch_in(cstring) RETURNS uddsketch IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_in_wrapper';
CREATE OR REPLACE FUNCTION uddsketch_out(uddsketch) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_out_wrapper';
CREATE TYPE uddsketch (
                                INTERNALLENGTH = variable,
                                INPUT = uddsketch_in,
                                OUTPUT = uddsketch_out,
                                STORAGE = extended
                            );
-- ./src/uddsketch.rs:25:0
CREATE OR REPLACE FUNCTION "uddsketch_trans"("state" internal, "size" int, "max_error" double precision, "value" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_trans_wrapper';
-- ./src/uddsketch.rs:54:0
CREATE OR REPLACE FUNCTION "percentile_agg_trans"("state" internal, "value" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'percentile_agg_trans_wrapper';
-- ./src/uddsketch.rs:66:0
CREATE OR REPLACE FUNCTION "uddsketch_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_combine_wrapper';
-- ./src/uddsketch.rs:91:0
CREATE OR REPLACE FUNCTION "uddsketch_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_serialize_wrapper';
-- ./src/uddsketch.rs:99:0
CREATE OR REPLACE FUNCTION "uddsketch_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_deserialize_wrapper';
-- ./src/uddsketch.rs:320:0
CREATE OR REPLACE FUNCTION "uddsketch_final"("state" internal) RETURNS UddSketch IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_final_wrapper';
CREATE AGGREGATE uddsketch(
    size int, max_error DOUBLE PRECISION, value DOUBLE PRECISION
) (
    sfunc = uddsketch_trans,
    stype = internal,
    finalfunc = uddsketch_final,
    combinefunc = uddsketch_combine,
    serialfunc = uddsketch_serialize,
    deserialfunc = uddsketch_deserialize,
    parallel = safe
);
CREATE AGGREGATE percentile_agg(value DOUBLE PRECISION)
(
    sfunc = percentile_agg_trans,
    stype = internal,
    finalfunc = uddsketch_final,
    combinefunc = uddsketch_combine,
    serialfunc = uddsketch_serialize,
    deserialfunc = uddsketch_deserialize,
    parallel = safe
);
-- ./src/uddsketch.rs:440:0
CREATE OR REPLACE FUNCTION "uddsketch_compound_trans"("state" internal, "value" UddSketch) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_compound_trans_wrapper';
CREATE AGGREGATE rollup(
    sketch uddsketch
) (
    sfunc = uddsketch_compound_trans,
    stype = internal,
    finalfunc = uddsketch_final,
    combinefunc = uddsketch_combine,
    serialfunc = uddsketch_serialize,
    deserialfunc = uddsketch_deserialize,
    parallel = safe
);
-- ./src/uddsketch.rs:478:0
CREATE OR REPLACE FUNCTION "arrow_uddsketch_approx_percentile"("sketch" UddSketch, "accessor" toolkit_experimental.AccessorApproxPercentile) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_uddsketch_approx_percentile_wrapper';
-- ./src/uddsketch.rs:488:0
CREATE OR REPLACE FUNCTION approx_percentile("percentile" double precision, "sketch" UddSketch) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_approx_percentile_wrapper';
-- ./src/uddsketch.rs:502:0
CREATE OR REPLACE FUNCTION "arrow_uddsketch_approx_rank"("sketch" UddSketch, "accessor" toolkit_experimental.AccessorApproxRank) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_uddsketch_approx_rank_wrapper';
-- ./src/uddsketch.rs:512:0
CREATE OR REPLACE FUNCTION approx_percentile_rank("value" double precision, "sketch" UddSketch) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_approx_percentile_rank_wrapper';
-- ./src/uddsketch.rs:525:0
CREATE OR REPLACE FUNCTION "arrow_uddsketch_num_vals"("sketch" UddSketch, "accessor" toolkit_experimental.AccessorNumVals) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_uddsketch_num_vals_wrapper';
-- ./src/uddsketch.rs:536:0
CREATE OR REPLACE FUNCTION num_vals("sketch" UddSketch) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_num_vals_wrapper';
-- ./src/uddsketch.rs:544:0
CREATE OR REPLACE FUNCTION "arrow_uddsketch_mean"("sketch" UddSketch, "accessor" toolkit_experimental.AccessorMean) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_uddsketch_mean_wrapper';
-- ./src/uddsketch.rs:556:0
CREATE OR REPLACE FUNCTION mean("sketch" UddSketch) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_mean_wrapper';
-- ./src/uddsketch.rs:568:0
CREATE OR REPLACE FUNCTION "arrow_uddsketch_error"("sketch" UddSketch, "accessor" toolkit_experimental.AccessorError) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_uddsketch_error_wrapper';
-- ./src/uddsketch.rs:579:0
CREATE OR REPLACE FUNCTION error("sketch" UddSketch) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'uddsketch_error_wrapper';
CREATE OPERATOR -> (
   PROCEDURE="arrow_uddsketch_approx_percentile",
   LEFTARG=UddSketch,
   RIGHTARG=toolkit_experimental.AccessorApproxPercentile
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_uddsketch_approx_rank",
   LEFTARG=UddSketch,
   RIGHTARG=toolkit_experimental.AccessorApproxRank
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_uddsketch_num_vals",
   LEFTARG=UddSketch,
   RIGHTARG=toolkit_experimental.AccessorNumVals
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_uddsketch_mean",
   LEFTARG=UddSketch,
   RIGHTARG=toolkit_experimental.AccessorMean
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_uddsketch_error",
   LEFTARG=UddSketch,
   RIGHTARG=toolkit_experimental.AccessorError
);



--
-- sql/time_weighted_average.generated.sql
--
CREATE TYPE timeweightsummary;
CREATE OR REPLACE FUNCTION timeweightsummary_in(cstring) RETURNS timeweightsummary IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'timeweightsummary_in_wrapper';
CREATE OR REPLACE FUNCTION timeweightsummary_out(timeweightsummary) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'timeweightsummary_out_wrapper';
CREATE TYPE timeweightsummary (
                                INTERNALLENGTH = variable,
                                INPUT = timeweightsummary_in,
                                OUTPUT = timeweightsummary_out,
                                STORAGE = extended
                            );
-- ./src/time_weighted_average.rs:90:0
CREATE OR REPLACE FUNCTION "time_weight_trans_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'time_weight_trans_serialize_wrapper';
-- ./src/time_weighted_average.rs:96:0
CREATE OR REPLACE FUNCTION "time_weight_trans_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'time_weight_trans_deserialize_wrapper';
-- ./src/time_weighted_average.rs:104:0
CREATE OR REPLACE FUNCTION "time_weight_trans"("state" internal, "method" text, "ts" TimestampTz, "val" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'time_weight_trans_wrapper';
-- ./src/time_weighted_average.rs:144:0
CREATE OR REPLACE FUNCTION "time_weight_summary_trans"("state" internal, "next" TimeWeightSummary) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'time_weight_summary_trans_wrapper';
-- ./src/time_weighted_average.rs:175:0
CREATE OR REPLACE FUNCTION "time_weight_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'time_weight_combine_wrapper';
-- ./src/time_weighted_average.rs:208:0
CREATE OR REPLACE FUNCTION "time_weight_final"("state" internal) RETURNS TimeWeightSummary IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'time_weight_final_wrapper';
CREATE AGGREGATE time_weight(method text, ts timestamptz, value DOUBLE PRECISION)
(
    sfunc = time_weight_trans,
    stype = internal,
    finalfunc = time_weight_final,
    combinefunc = time_weight_combine,
    serialfunc = time_weight_trans_serialize,
    deserialfunc = time_weight_trans_deserialize,
    parallel = restricted
);

CREATE AGGREGATE rollup(tws TimeWeightSummary)
(
    sfunc = time_weight_summary_trans,
    stype = internal,
    finalfunc = time_weight_final,
    combinefunc = time_weight_combine,
    serialfunc = time_weight_trans_serialize,
    deserialfunc = time_weight_trans_deserialize,
    parallel = restricted
);
-- ./src/time_weighted_average.rs:263:0
CREATE OR REPLACE FUNCTION "arrow_time_weighted_average_average"("sketch" TimeWeightSummary, "accessor" toolkit_experimental.AccessorAverage) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_time_weighted_average_average_wrapper';
-- ./src/time_weighted_average.rs:274:0
CREATE OR REPLACE FUNCTION average("tws" TimeWeightSummary) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'time_weighted_average_average_wrapper';
CREATE OPERATOR -> (
   PROCEDURE="arrow_time_weighted_average_average",
   LEFTARG=TimeWeightSummary,
   RIGHTARG=toolkit_experimental.AccessorAverage
);



--
-- sql/time_series.generated.sql
--
CREATE TYPE toolkit_experimental.timevector;
CREATE OR REPLACE FUNCTION toolkit_experimental.timevector_in(cstring) RETURNS toolkit_experimental.timevector IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'timevector_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.timevector_out(toolkit_experimental.timevector) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'timevector_out_wrapper';
CREATE TYPE toolkit_experimental.timevector (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.timevector_in,
                                OUTPUT = toolkit_experimental.timevector_out,
                                STORAGE = extended
                            );
-- ./src/time_series.rs:201:0
CREATE OR REPLACE FUNCTION toolkit_experimental."unnest"("series" toolkit_experimental.Timevector) RETURNS TABLE ("time" TimestampTz, "value" double precision) IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'unnest_wrapper';
-- ./src/time_series.rs:208:0
CREATE OR REPLACE FUNCTION toolkit_experimental."timevector_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'timevector_serialize_wrapper';
-- ./src/time_series.rs:216:0
CREATE OR REPLACE FUNCTION toolkit_experimental."timevector_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'timevector_deserialize_wrapper';
-- ./src/time_series.rs:225:0
CREATE OR REPLACE FUNCTION toolkit_experimental."timevector_trans"("state" internal, "time" TimestampTz, "value" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'timevector_trans_wrapper';
-- ./src/time_series.rs:282:0
CREATE OR REPLACE FUNCTION toolkit_experimental."timevector_compound_trans"("state" internal, "series" toolkit_experimental.Timevector) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'timevector_compound_trans_wrapper';
-- ./src/time_series.rs:335:0
CREATE OR REPLACE FUNCTION toolkit_experimental."timevector_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'timevector_combine_wrapper';
-- ./src/time_series.rs:456:0
CREATE OR REPLACE FUNCTION toolkit_experimental."timevector_final"("state" internal) RETURNS toolkit_experimental.Timevector IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'timevector_final_wrapper';
CREATE AGGREGATE toolkit_experimental.timevector(ts TIMESTAMPTZ, value DOUBLE PRECISION) (
    sfunc = toolkit_experimental.timevector_trans,
    stype = internal,
    finalfunc = toolkit_experimental.timevector_final,
    combinefunc = toolkit_experimental.timevector_combine,
    serialfunc = toolkit_experimental.timevector_serialize,
    deserialfunc = toolkit_experimental.timevector_deserialize,
    parallel = safe
);
CREATE AGGREGATE toolkit_experimental.rollup(
    toolkit_experimental.timevector
) (
    sfunc = toolkit_experimental.timevector_compound_trans,
    stype = internal,
    finalfunc = toolkit_experimental.timevector_final,
    combinefunc = toolkit_experimental.timevector_combine,
    serialfunc = toolkit_experimental.timevector_serialize,
    deserialfunc = toolkit_experimental.timevector_deserialize,
    parallel = safe
);



--
-- sql/lttb.generated.sql
--
-- ./src/lttb.rs:23:0
CREATE OR REPLACE FUNCTION toolkit_experimental."lttb_trans"("state" internal, "time" TimestampTz, "val" double precision, "resolution" integer) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'lttb_trans_wrapper';
-- ./src/lttb.rs:59:0
CREATE OR REPLACE FUNCTION toolkit_experimental."lttb_final"("state" internal) RETURNS toolkit_experimental.Timevector IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'lttb_final_wrapper';
CREATE AGGREGATE toolkit_experimental.lttb(ts TIMESTAMPTZ, value DOUBLE PRECISION, resolution INT) (
    sfunc = toolkit_experimental.lttb_trans,
    stype = internal,
    finalfunc = toolkit_experimental.lttb_final
);
-- ./src/lttb.rs:169:0
CREATE OR REPLACE FUNCTION toolkit_experimental.lttb("series" toolkit_experimental.Timevector, "threshold" integer) RETURNS toolkit_experimental.Timevector IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'lttb_on_timevector_wrapper';



--
-- sql/asap.generated.sql
--
-- ./src/asap.rs:15:0
CREATE OR REPLACE FUNCTION toolkit_experimental."asap_smooth_raw"("data" double precision[], "resolution" integer) RETURNS double precision[] IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'asap_smooth_raw_wrapper';
-- ./src/asap.rs:35:0
CREATE OR REPLACE FUNCTION toolkit_experimental."asap_trans"("state" internal, "ts" TimestampTz, "val" double precision, "resolution" integer) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'asap_trans_wrapper';
-- ./src/asap.rs:99:0
CREATE OR REPLACE FUNCTION toolkit_experimental."asap_final"("state" internal) RETURNS toolkit_experimental.Timevector IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'asap_final_wrapper';
-- ./src/asap.rs:149:0
CREATE OR REPLACE FUNCTION toolkit_experimental.asap_smooth("series" toolkit_experimental.Timevector, "resolution" integer) RETURNS toolkit_experimental.Timevector IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'asap_on_timevector_wrapper';
CREATE AGGREGATE toolkit_experimental.asap_smooth(ts TIMESTAMPTZ, value DOUBLE PRECISION, resolution INT) (
    sfunc = toolkit_experimental.asap_trans,
    stype = internal,
    finalfunc = toolkit_experimental.asap_final
);



--
-- sql/counter_agg.generated.sql
--
CREATE TYPE countersummary;
CREATE OR REPLACE FUNCTION countersummary_in(cstring) RETURNS countersummary IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'countersummary_in_wrapper';
CREATE OR REPLACE FUNCTION countersummary_out(countersummary) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'countersummary_out_wrapper';
CREATE TYPE countersummary (
                                INTERNALLENGTH = variable,
                                INPUT = countersummary_in,
                                OUTPUT = countersummary_out,
                                STORAGE = extended
                            );
-- ./src/counter_agg.rs:163:0
CREATE OR REPLACE FUNCTION "counter_summary_trans_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_summary_trans_serialize_wrapper';
-- ./src/counter_agg.rs:171:0
CREATE OR REPLACE FUNCTION "counter_summary_trans_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_summary_trans_deserialize_wrapper';
-- ./src/counter_agg.rs:179:0
CREATE OR REPLACE FUNCTION "counter_agg_trans"("state" internal, "ts" TimestampTz, "val" double precision, "bounds" tstzrange) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_trans_wrapper';
-- ./src/counter_agg.rs:209:0
CREATE OR REPLACE FUNCTION "counter_agg_trans_no_bounds"("state" internal, "ts" TimestampTz, "val" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_trans_no_bounds_wrapper';
-- ./src/counter_agg.rs:220:0
CREATE OR REPLACE FUNCTION "counter_agg_summary_trans"("state" internal, "value" CounterSummary) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_summary_trans_wrapper';
-- ./src/counter_agg.rs:241:0
CREATE OR REPLACE FUNCTION "counter_agg_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_combine_wrapper';
-- ./src/counter_agg.rs:266:0
CREATE OR REPLACE FUNCTION "counter_agg_final"("state" internal) RETURNS CounterSummary IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_final_wrapper';
CREATE AGGREGATE counter_agg( ts timestamptz, value DOUBLE PRECISION, bounds tstzrange )
(
    sfunc = counter_agg_trans,
    stype = internal,
    finalfunc = counter_agg_final,
    combinefunc = counter_agg_combine,
    serialfunc = counter_summary_trans_serialize,
    deserialfunc = counter_summary_trans_deserialize,
    parallel = restricted
);
CREATE AGGREGATE counter_agg( ts timestamptz, value DOUBLE PRECISION )
(
    sfunc = counter_agg_trans_no_bounds,
    stype = internal,
    finalfunc = counter_agg_final,
    combinefunc = counter_agg_combine,
    serialfunc = counter_summary_trans_serialize,
    deserialfunc = counter_summary_trans_deserialize,
    parallel = restricted
);
CREATE AGGREGATE rollup(cs CounterSummary)
(
    sfunc = counter_agg_summary_trans,
    stype = internal,
    finalfunc = counter_agg_final,
    combinefunc = counter_agg_combine,
    serialfunc = counter_summary_trans_serialize,
    deserialfunc = counter_summary_trans_deserialize,
    parallel = restricted
);
-- ./src/counter_agg.rs:334:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_delta"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorDelta) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_delta_wrapper';
-- ./src/counter_agg.rs:344:0
CREATE OR REPLACE FUNCTION delta("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_delta_wrapper';
-- ./src/counter_agg.rs:352:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_rate"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorRate) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_rate_wrapper';
-- ./src/counter_agg.rs:362:0
CREATE OR REPLACE FUNCTION rate("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_rate_wrapper';
-- ./src/counter_agg.rs:370:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_time_delta"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorTimeDelta) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_time_delta_wrapper';
-- ./src/counter_agg.rs:380:0
CREATE OR REPLACE FUNCTION time_delta("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_time_delta_wrapper';
-- ./src/counter_agg.rs:388:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_irate_left"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorIRateLeft) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_irate_left_wrapper';
-- ./src/counter_agg.rs:398:0
CREATE OR REPLACE FUNCTION irate_left("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_irate_left_wrapper';
-- ./src/counter_agg.rs:406:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_irate_right"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorIRateRight) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_irate_right_wrapper';
-- ./src/counter_agg.rs:416:0
CREATE OR REPLACE FUNCTION irate_right("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_irate_right_wrapper';
-- ./src/counter_agg.rs:424:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_idelta_left"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorIDeltaLeft) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_idelta_left_wrapper';
-- ./src/counter_agg.rs:434:0
CREATE OR REPLACE FUNCTION idelta_left("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_idelta_left_wrapper';
-- ./src/counter_agg.rs:442:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_idelta_right"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorIDeltaRight) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_idelta_right_wrapper';
-- ./src/counter_agg.rs:452:0
CREATE OR REPLACE FUNCTION idelta_right("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_idelta_right_wrapper';
-- ./src/counter_agg.rs:460:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_with_bounds"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorWithBounds) RETURNS CounterSummary IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_with_bounds_wrapper';
-- ./src/counter_agg.rs:472:0
CREATE OR REPLACE FUNCTION with_bounds("summary" CounterSummary, "bounds" tstzrange) RETURNS CounterSummary IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_with_bounds_wrapper';
-- ./src/counter_agg.rs:486:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_extrapolated_delta"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorExtrapolatedDelta) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_extrapolated_delta_wrapper';
-- ./src/counter_agg.rs:497:0
CREATE OR REPLACE FUNCTION extrapolated_delta("summary" CounterSummary, "method" text) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_extrapolated_delta_wrapper';
-- ./src/counter_agg.rs:510:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_extrapolated_rate"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorExtrapolatedRate) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_extrapolated_rate_wrapper';
-- ./src/counter_agg.rs:521:0
CREATE OR REPLACE FUNCTION extrapolated_rate("summary" CounterSummary, "method" text) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_extrapolated_rate_wrapper';
-- ./src/counter_agg.rs:533:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_num_elements"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorNumElements) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_num_elements_wrapper';
-- ./src/counter_agg.rs:543:0
CREATE OR REPLACE FUNCTION num_elements("summary" CounterSummary) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_num_elements_wrapper';
-- ./src/counter_agg.rs:551:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_num_changes"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorNumChanges) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_num_changes_wrapper';
-- ./src/counter_agg.rs:561:0
CREATE OR REPLACE FUNCTION num_changes("summary" CounterSummary) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_num_changes_wrapper';
-- ./src/counter_agg.rs:569:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_num_resets"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorNumResets) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_num_resets_wrapper';
-- ./src/counter_agg.rs:579:0
CREATE OR REPLACE FUNCTION num_resets("summary" CounterSummary) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_num_resets_wrapper';
-- ./src/counter_agg.rs:587:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_slope"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorSlope) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_slope_wrapper';
-- ./src/counter_agg.rs:597:0
CREATE OR REPLACE FUNCTION slope("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_slope_wrapper';
-- ./src/counter_agg.rs:605:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_intercept"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorIntercept) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_intercept_wrapper';
-- ./src/counter_agg.rs:615:0
CREATE OR REPLACE FUNCTION intercept("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_intercept_wrapper';
-- ./src/counter_agg.rs:623:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_corr"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorCorr) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_corr_wrapper';
-- ./src/counter_agg.rs:633:0
CREATE OR REPLACE FUNCTION corr("summary" CounterSummary) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_corr_wrapper';
-- ./src/counter_agg.rs:641:0
CREATE OR REPLACE FUNCTION "arrow_counter_agg_zero_time"("sketch" CounterSummary, "accessor" toolkit_experimental.AccessorZeroTime) RETURNS TimestampTz IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_counter_agg_zero_time_wrapper';
-- ./src/counter_agg.rs:651:0
CREATE OR REPLACE FUNCTION counter_zero_time("summary" CounterSummary) RETURNS TimestampTz IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'counter_agg_counter_zero_time_wrapper';
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_delta",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorDelta
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_rate",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorRate
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_time_delta",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorTimeDelta
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_irate_left",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorIRateLeft
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_irate_right",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorIRateRight
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_idelta_left",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorIDeltaLeft
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_idelta_right",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorIDeltaRight
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_with_bounds",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorWithBounds
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_extrapolated_delta",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorExtrapolatedDelta
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_extrapolated_rate",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorExtrapolatedRate
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_num_elements",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorNumElements
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_num_changes",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorNumChanges
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_num_resets",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorNumResets
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_slope",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorSlope
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_intercept",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorIntercept
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_corr",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorCorr
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_counter_agg_zero_time",
   LEFTARG=CounterSummary,
   RIGHTARG=toolkit_experimental.AccessorZeroTime
);



--
-- sql/utilities.generated.sql
--
-- ./src/utilities.rs:4:0
CREATE OR REPLACE FUNCTION toolkit_experimental.generate_periodic_normal_series("series_start" TimestampTz, "rng_seed" bigint) RETURNS TABLE ("time" TimestampTz, "value" double precision) LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'default_generate_periodic_normal_series_wrapper';
-- ./src/utilities.rs:29:0
CREATE OR REPLACE FUNCTION toolkit_experimental."generate_periodic_normal_series"("series_start" TimestampTz, "series_len" bigint, "sample_interval" bigint, "base_value" double precision, "period" bigint, "periodic_magnitude" double precision, "standard_deviation" double precision, "rng_seed" bigint) RETURNS TABLE ("time" TimestampTz, "value" double precision) LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'generate_periodic_normal_series_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.to_epoch(timestamptz) RETURNS DOUBLE PRECISION LANGUAGE SQL IMMUTABLE PARALLEL SAFE AS $$
SELECT EXTRACT(EPOCH FROM $1);
$$;



--
-- sql/stats_agg.generated.sql
--
CREATE TYPE statssummary1d;
CREATE OR REPLACE FUNCTION statssummary1d_in(cstring) RETURNS statssummary1d IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'statssummary1d_in_wrapper';
CREATE OR REPLACE FUNCTION statssummary1d_out(statssummary1d) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'statssummary1d_out_wrapper';
CREATE TYPE statssummary1d (
                                INTERNALLENGTH = variable,
                                INPUT = statssummary1d_in,
                                OUTPUT = statssummary1d_out,
                                STORAGE = extended
                            );
CREATE TYPE statssummary2d;
CREATE OR REPLACE FUNCTION statssummary2d_in(cstring) RETURNS statssummary2d IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'statssummary2d_in_wrapper';
CREATE OR REPLACE FUNCTION statssummary2d_out(statssummary2d) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'statssummary2d_out_wrapper';
CREATE TYPE statssummary2d (
                                INTERNALLENGTH = variable,
                                INPUT = statssummary2d_in,
                                OUTPUT = statssummary2d_out,
                                STORAGE = extended
                            );
-- ./src/stats_agg.rs:124:0
CREATE OR REPLACE FUNCTION "stats1d_trans_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_trans_serialize_wrapper';
-- ./src/stats_agg.rs:132:0
CREATE OR REPLACE FUNCTION "stats1d_trans_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_trans_deserialize_wrapper';
-- ./src/stats_agg.rs:141:0
CREATE OR REPLACE FUNCTION "stats2d_trans_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_trans_serialize_wrapper';
-- ./src/stats_agg.rs:149:0
CREATE OR REPLACE FUNCTION "stats2d_trans_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_trans_deserialize_wrapper';
-- ./src/stats_agg.rs:158:0
CREATE OR REPLACE FUNCTION "stats1d_trans"("state" internal, "val" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_trans_wrapper';
-- ./src/stats_agg.rs:186:0
CREATE OR REPLACE FUNCTION "stats2d_trans"("state" internal, "y" double precision, "x" double precision) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_trans_wrapper';
-- ./src/stats_agg.rs:220:0
CREATE OR REPLACE FUNCTION "stats1d_inv_trans"("state" internal, "val" double precision) RETURNS internal IMMUTABLE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_inv_trans_wrapper';
-- ./src/stats_agg.rs:244:0
CREATE OR REPLACE FUNCTION "stats2d_inv_trans"("state" internal, "y" double precision, "x" double precision) RETURNS internal IMMUTABLE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_inv_trans_wrapper';
-- ./src/stats_agg.rs:275:0
CREATE OR REPLACE FUNCTION "stats1d_summary_trans"("state" internal, "value" StatsSummary1D) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_summary_trans_wrapper';
-- ./src/stats_agg.rs:300:0
CREATE OR REPLACE FUNCTION "stats2d_summary_trans"("state" internal, "value" StatsSummary2D) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_summary_trans_wrapper';
-- ./src/stats_agg.rs:323:0
CREATE OR REPLACE FUNCTION "stats1d_summary_inv_trans"("state" internal, "value" StatsSummary1D) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_summary_inv_trans_wrapper';
-- ./src/stats_agg.rs:348:0
CREATE OR REPLACE FUNCTION "stats2d_summary_inv_trans"("state" internal, "value" StatsSummary2D) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_summary_inv_trans_wrapper';
-- ./src/stats_agg.rs:373:0
CREATE OR REPLACE FUNCTION "stats1d_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_combine_wrapper';
-- ./src/stats_agg.rs:402:0
CREATE OR REPLACE FUNCTION "stats2d_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_combine_wrapper';
-- ./src/stats_agg.rs:431:0
CREATE OR REPLACE FUNCTION "stats1d_final"("state" internal) RETURNS StatsSummary1D IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_final_wrapper';
-- ./src/stats_agg.rs:446:0
CREATE OR REPLACE FUNCTION "stats2d_final"("state" internal) RETURNS StatsSummary2D IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_final_wrapper';
CREATE AGGREGATE stats_agg( value DOUBLE PRECISION )
(
    sfunc = stats1d_trans,
    stype = internal,
    finalfunc = stats1d_final,
    combinefunc = stats1d_combine,
    serialfunc = stats1d_trans_serialize,
    deserialfunc = stats1d_trans_deserialize,
    msfunc = stats1d_trans,
    minvfunc = stats1d_inv_trans,
    mstype = internal,
    mfinalfunc = stats1d_final,
    parallel = safe
);
CREATE AGGREGATE stats_agg_no_inv( value DOUBLE PRECISION )
(
    sfunc = stats1d_trans,
    stype = internal,
    finalfunc = stats1d_final,
    combinefunc = stats1d_combine,
    serialfunc = stats1d_trans_serialize,
    deserialfunc = stats1d_trans_deserialize,
    parallel = safe
);
CREATE AGGREGATE stats_agg( y DOUBLE PRECISION, x DOUBLE PRECISION )
(
    sfunc = stats2d_trans,
    stype = internal,
    finalfunc = stats2d_final,
    combinefunc = stats2d_combine,
    serialfunc = stats2d_trans_serialize,
    deserialfunc = stats2d_trans_deserialize,
    msfunc = stats2d_trans,
    minvfunc = stats2d_inv_trans,
    mstype = internal,
    mfinalfunc = stats2d_final,
    parallel = safe
);
CREATE AGGREGATE stats_agg_no_inv( y DOUBLE PRECISION, x DOUBLE PRECISION )
(
    sfunc = stats2d_trans,
    stype = internal,
    finalfunc = stats2d_final,
    combinefunc = stats2d_combine,
    serialfunc = stats2d_trans_serialize,
    deserialfunc = stats2d_trans_deserialize,
    parallel = safe
);
CREATE AGGREGATE rollup(ss statssummary1d)
(
    sfunc = stats1d_summary_trans,
    stype = internal,
    finalfunc = stats1d_final,
    combinefunc = stats1d_combine,
    serialfunc = stats1d_trans_serialize,
    deserialfunc = stats1d_trans_deserialize,
    parallel = safe
);
CREATE AGGREGATE rolling(ss statssummary1d)
(
    sfunc = stats1d_summary_trans,
    stype = internal,
    finalfunc = stats1d_final,
    combinefunc = stats1d_combine,
    serialfunc = stats1d_trans_serialize,
    deserialfunc = stats1d_trans_deserialize,
    msfunc = stats1d_summary_trans,
    minvfunc = stats1d_summary_inv_trans,
    mstype = internal,
    mfinalfunc = stats1d_final,
    parallel = safe
);
CREATE AGGREGATE rollup(ss statssummary2d)
(
    sfunc = stats2d_summary_trans,
    stype = internal,
    finalfunc = stats2d_final,
    combinefunc = stats2d_combine,
    serialfunc = stats2d_trans_serialize,
    deserialfunc = stats2d_trans_deserialize,
    parallel = safe
);
CREATE AGGREGATE rolling(ss statssummary2d)
(
    sfunc = stats2d_summary_trans,
    stype = internal,
    finalfunc = stats2d_final,
    combinefunc = stats2d_combine,
    serialfunc = stats2d_trans_serialize,
    deserialfunc = stats2d_trans_deserialize,
    msfunc = stats2d_summary_trans,
    minvfunc = stats2d_summary_inv_trans,
    mstype = internal,
    mfinalfunc = stats2d_final,
    parallel = safe
);
-- ./src/stats_agg.rs:595:0
CREATE OR REPLACE FUNCTION "arrow_stats1d_average"("sketch" StatsSummary1D, "accessor" toolkit_experimental.AccessorAverage) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats1d_average_wrapper';
-- ./src/stats_agg.rs:605:0
CREATE OR REPLACE FUNCTION average("summary" StatsSummary1D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_average_wrapper';
-- ./src/stats_agg.rs:613:0
CREATE OR REPLACE FUNCTION "arrow_stats1d_sum"("sketch" StatsSummary1D, "accessor" toolkit_experimental.AccessorSum) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats1d_sum_wrapper';
-- ./src/stats_agg.rs:623:0
CREATE OR REPLACE FUNCTION sum("summary" StatsSummary1D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_sum_wrapper';
-- ./src/stats_agg.rs:631:0
CREATE OR REPLACE FUNCTION "arrow_stats1d_stddev"("sketch" StatsSummary1D, "accessor" toolkit_experimental.AccessorStdDev) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats1d_stddev_wrapper';
-- ./src/stats_agg.rs:642:0
CREATE OR REPLACE FUNCTION stddev("summary" StatsSummary1D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_stddev_wrapper';
-- ./src/stats_agg.rs:654:0
CREATE OR REPLACE FUNCTION "arrow_stats1d_variance"("sketch" StatsSummary1D, "accessor" toolkit_experimental.AccessorVariance) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats1d_variance_wrapper';
-- ./src/stats_agg.rs:665:0
CREATE OR REPLACE FUNCTION variance("summary" StatsSummary1D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_variance_wrapper';
-- ./src/stats_agg.rs:677:0
CREATE OR REPLACE FUNCTION "arrow_stats1d_skewness"("sketch" StatsSummary1D, "accessor" toolkit_experimental.AccessorSkewness) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats1d_skewness_wrapper';
-- ./src/stats_agg.rs:688:0
CREATE OR REPLACE FUNCTION skewness("summary" StatsSummary1D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_skewness_wrapper';
-- ./src/stats_agg.rs:700:0
CREATE OR REPLACE FUNCTION "arrow_stats1d_kurtosis"("sketch" StatsSummary1D, "accessor" toolkit_experimental.AccessorKurtosis) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats1d_kurtosis_wrapper';
-- ./src/stats_agg.rs:711:0
CREATE OR REPLACE FUNCTION kurtosis("summary" StatsSummary1D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_kurtosis_wrapper';
-- ./src/stats_agg.rs:724:0
CREATE OR REPLACE FUNCTION "arrow_stats1d_num_vals"("sketch" StatsSummary1D, "accessor" toolkit_experimental.AccessorNumVals) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats1d_num_vals_wrapper';
-- ./src/stats_agg.rs:734:0
CREATE OR REPLACE FUNCTION num_vals("summary" StatsSummary1D) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats1d_num_vals_wrapper';
-- ./src/stats_agg.rs:742:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_average_x"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorAverageX) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_average_x_wrapper';
-- ./src/stats_agg.rs:752:0
CREATE OR REPLACE FUNCTION average_x("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_average_x_wrapper';
-- ./src/stats_agg.rs:760:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_average_y"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorAverageY) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_average_y_wrapper';
-- ./src/stats_agg.rs:770:0
CREATE OR REPLACE FUNCTION average_y("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_average_y_wrapper';
-- ./src/stats_agg.rs:778:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_sum_x"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorSumX) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_sum_x_wrapper';
-- ./src/stats_agg.rs:788:0
CREATE OR REPLACE FUNCTION sum_x("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_sum_x_wrapper';
-- ./src/stats_agg.rs:796:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_sum_y"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorSumY) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_sum_y_wrapper';
-- ./src/stats_agg.rs:806:0
CREATE OR REPLACE FUNCTION sum_y("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_sum_y_wrapper';
-- ./src/stats_agg.rs:814:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_stdddev_x"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorStdDevX) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_stdddev_x_wrapper';
-- ./src/stats_agg.rs:825:0
CREATE OR REPLACE FUNCTION stddev_x("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_stddev_x_wrapper';
-- ./src/stats_agg.rs:837:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_stdddev_y"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorStdDevY) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_stdddev_y_wrapper';
-- ./src/stats_agg.rs:848:0
CREATE OR REPLACE FUNCTION stddev_y("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_stddev_y_wrapper';
-- ./src/stats_agg.rs:860:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_variance_x"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorVarianceX) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_variance_x_wrapper';
-- ./src/stats_agg.rs:871:0
CREATE OR REPLACE FUNCTION variance_x("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_variance_x_wrapper';
-- ./src/stats_agg.rs:883:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_variance_y"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorVarianceY) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_variance_y_wrapper';
-- ./src/stats_agg.rs:894:0
CREATE OR REPLACE FUNCTION variance_y("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_variance_y_wrapper';
-- ./src/stats_agg.rs:906:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_skewness_x"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorSkewnessX) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_skewness_x_wrapper';
-- ./src/stats_agg.rs:917:0
CREATE OR REPLACE FUNCTION skewness_x("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_skewness_x_wrapper';
-- ./src/stats_agg.rs:929:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_skewness_y"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorSkewnessY) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_skewness_y_wrapper';
-- ./src/stats_agg.rs:940:0
CREATE OR REPLACE FUNCTION skewness_y("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_skewness_y_wrapper';
-- ./src/stats_agg.rs:952:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_kurtosis_x"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorKurtosisX) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_kurtosis_x_wrapper';
-- ./src/stats_agg.rs:963:0
CREATE OR REPLACE FUNCTION kurtosis_x("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_kurtosis_x_wrapper';
-- ./src/stats_agg.rs:975:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_kurtosis_y"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorKurtosisY) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_kurtosis_y_wrapper';
-- ./src/stats_agg.rs:986:0
CREATE OR REPLACE FUNCTION kurtosis_y("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_kurtosis_y_wrapper';
-- ./src/stats_agg.rs:998:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_num_vals"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorNumVals) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_num_vals_wrapper';
-- ./src/stats_agg.rs:1008:0
CREATE OR REPLACE FUNCTION num_vals("summary" StatsSummary2D) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_num_vals_wrapper';
-- ./src/stats_agg.rs:1016:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_slope"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorSlope) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_slope_wrapper';
-- ./src/stats_agg.rs:1026:0
CREATE OR REPLACE FUNCTION slope("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_slope_wrapper';
-- ./src/stats_agg.rs:1034:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_corr"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorCorr) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_corr_wrapper';
-- ./src/stats_agg.rs:1044:0
CREATE OR REPLACE FUNCTION corr("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_corr_wrapper';
-- ./src/stats_agg.rs:1052:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_intercept"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorIntercept) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_intercept_wrapper';
-- ./src/stats_agg.rs:1062:0
CREATE OR REPLACE FUNCTION intercept("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_intercept_wrapper';
-- ./src/stats_agg.rs:1070:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_x_intercept"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorXIntercept) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_x_intercept_wrapper';
-- ./src/stats_agg.rs:1080:0
CREATE OR REPLACE FUNCTION x_intercept("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_x_intercept_wrapper';
-- ./src/stats_agg.rs:1088:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_determination_coeff"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorDeterminationCoeff) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_determination_coeff_wrapper';
-- ./src/stats_agg.rs:1098:0
CREATE OR REPLACE FUNCTION determination_coeff("summary" StatsSummary2D) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_determination_coeff_wrapper';
-- ./src/stats_agg.rs:1106:0
CREATE OR REPLACE FUNCTION "arrow_stats2d_covar"("sketch" StatsSummary2D, "accessor" toolkit_experimental.AccessorCovar) RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_stats2d_covar_wrapper';
-- ./src/stats_agg.rs:1117:0
CREATE OR REPLACE FUNCTION covariance("summary" StatsSummary2D, "method" text DEFAULT 'sample') RETURNS double precision IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'stats2d_covar_wrapper';
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats1d_average",
   LEFTARG=StatsSummary1D,
   RIGHTARG=toolkit_experimental.AccessorAverage
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats1d_sum",
   LEFTARG=StatsSummary1D,
   RIGHTARG=toolkit_experimental.AccessorSum
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats1d_stddev",
   LEFTARG=StatsSummary1D,
   RIGHTARG=toolkit_experimental.AccessorStdDev
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats1d_variance",
   LEFTARG=StatsSummary1D,
   RIGHTARG=toolkit_experimental.AccessorVariance
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats1d_skewness",
   LEFTARG=StatsSummary1D,
   RIGHTARG=toolkit_experimental.AccessorSkewness
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats1d_kurtosis",
   LEFTARG=StatsSummary1D,
   RIGHTARG=toolkit_experimental.AccessorKurtosis
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats1d_num_vals",
   LEFTARG=StatsSummary1D,
   RIGHTARG=toolkit_experimental.AccessorNumVals
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_average_x",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorAverageX
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_average_y",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorAverageY
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_sum_x",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorSumX
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_sum_y",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorSumY
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_stdddev_x",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorStdDevX
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_stdddev_y",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorStdDevY
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_variance_x",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorVarianceX
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_variance_y",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorVarianceY
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_skewness_x",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorSkewnessX
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_skewness_y",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorSkewnessY
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_kurtosis_x",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorKurtosisX
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_kurtosis_y",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorKurtosisY
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_num_vals",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorNumVals
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_slope",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorSlope
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_corr",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorCorr
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_intercept",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorIntercept
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_x_intercept",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorXIntercept
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_determination_coeff",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorDeterminationCoeff
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_stats2d_covar",
   LEFTARG=StatsSummary2D,
   RIGHTARG=toolkit_experimental.AccessorCovar
);



--
-- sql/time_series_pipeline.generated.sql
--
CREATE TYPE toolkit_experimental.unstabletimevectorpipeline;
CREATE OR REPLACE FUNCTION toolkit_experimental.unstabletimevectorpipeline_in(cstring) RETURNS toolkit_experimental.unstabletimevectorpipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'unstabletimevectorpipeline_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.unstabletimevectorpipeline_out(toolkit_experimental.unstabletimevectorpipeline) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'unstabletimevectorpipeline_out_wrapper';
CREATE TYPE toolkit_experimental.unstabletimevectorpipeline (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.unstabletimevectorpipeline_in,
                                OUTPUT = toolkit_experimental.unstabletimevectorpipeline_out,
                                STORAGE = extended
                            );
-- ./src/time_series/pipeline.rs:145:0
CREATE OR REPLACE FUNCTION "arrow_run_pipeline"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.UnstableTimevectorPipeline) RETURNS toolkit_experimental.Timevector IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_run_pipeline_wrapper';
-- ./src/time_series/pipeline.rs:196:0
CREATE OR REPLACE FUNCTION "arrow_add_unstable_element"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "element" toolkit_experimental.UnstableTimevectorPipeline) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_add_unstable_element_wrapper';
-- ./src/time_series/pipeline.rs:208:0
CREATE OR REPLACE FUNCTION toolkit_experimental.toolkit_pipeline_support("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_support_wrapper';
ALTER FUNCTION "arrow_run_pipeline" SUPPORT toolkit_experimental.toolkit_pipeline_support;
ALTER FUNCTION "arrow_add_unstable_element" SUPPORT toolkit_experimental.toolkit_pipeline_support;
-- ./src/time_series/pipeline.rs:332:0
CREATE OR REPLACE FUNCTION toolkit_experimental."run_user_pipeline_element"("timevector" toolkit_experimental.Timevector, "function" regproc) RETURNS toolkit_experimental.Timevector STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'run_user_pipeline_element_wrapper';
-- ./src/time_series/pipeline.rs:341:0
CREATE OR REPLACE FUNCTION toolkit_experimental."build_unstable_user_pipeline"("first" regproc, "second" regproc) RETURNS toolkit_experimental.UnstableTimevectorPipeline STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'build_unstable_user_pipeline_wrapper';
-- ./src/time_series/pipeline.rs:358:0
CREATE OR REPLACE FUNCTION toolkit_experimental."add_user_pipeline_element"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "function" regproc) RETURNS toolkit_experimental.UnstableTimevectorPipeline STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'add_user_pipeline_element_wrapper';
CREATE OPERATOR ->> (
    PROCEDURE=toolkit_experimental."run_user_pipeline_element",
    LEFTARG=toolkit_experimental.Timevector,
    RIGHTARG=regproc
);

CREATE OPERATOR ->> (
    PROCEDURE=toolkit_experimental."build_unstable_user_pipeline",
    LEFTARG=regproc,
    RIGHTARG=regproc
);

CREATE OPERATOR ->> (
    PROCEDURE=toolkit_experimental."add_user_pipeline_element",
    LEFTARG=toolkit_experimental.UnstableTimevectorPipeline,
    RIGHTARG=regproc
);
-- ./src/time_series/pipeline.rs:405:0
CREATE OR REPLACE FUNCTION toolkit_experimental.lttb("resolution" integer) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'lttb_pipeline_element_wrapper';
CREATE OPERATOR -> (
   PROCEDURE="arrow_run_pipeline",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.UnstableTimevectorPipeline
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_add_unstable_element",
   LEFTARG=toolkit_experimental.UnstableTimevectorPipeline,
   RIGHTARG=toolkit_experimental.UnstableTimevectorPipeline
);



--
-- sql/time_series_pipeline_delta.generated.sql
--
-- ./src/time_series/pipeline/delta.rs:7:0
CREATE OR REPLACE FUNCTION toolkit_experimental.delta_cast("accessor" toolkit_experimental.AccessorDelta) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'delta_pipeline_element_wrapper';
    CREATE CAST (toolkit_experimental.AccessorDelta AS toolkit_experimental.UnstableTimevectorPipeline)
        WITH FUNCTION toolkit_experimental.delta_cast
        AS IMPLICIT;



--
-- sql/time_series_pipeline_fill_holes.generated.sql
--
-- ./src/time_series/pipeline/fill_holes.rs:82:0
CREATE OR REPLACE FUNCTION toolkit_experimental.fill_holes("fill_method" text) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'holefill_pipeline_element_wrapper';



--
-- sql/time_series_pipeline_lambda.generated.sql
--
CREATE TYPE toolkit_experimental.lambda;
CREATE OR REPLACE FUNCTION toolkit_experimental.lambda_in(cstring) RETURNS toolkit_experimental.lambda IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'lambda_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.lambda_out(toolkit_experimental.lambda) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'lambda_out_wrapper';
CREATE TYPE toolkit_experimental.lambda (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.lambda_in,
                                OUTPUT = toolkit_experimental.lambda_out,
                                STORAGE = extended
                            );
-- ./src/time_series/pipeline/lambda.rs:75:0
CREATE OR REPLACE FUNCTION toolkit_experimental."bool_lambda"("lambda" toolkit_experimental.Lambda, "time" TimestampTz, "value" double precision) RETURNS bool STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'bool_lambda_wrapper';
-- ./src/time_series/pipeline/lambda.rs:93:0
CREATE OR REPLACE FUNCTION toolkit_experimental."f64_lambda"("lambda" toolkit_experimental.Lambda, "time" TimestampTz, "value" double precision) RETURNS double precision STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'f64_lambda_wrapper';
-- ./src/time_series/pipeline/lambda.rs:111:0
CREATE OR REPLACE FUNCTION toolkit_experimental."ttz_lambda"("lambda" toolkit_experimental.Lambda, "time" TimestampTz, "value" double precision) RETURNS TimestampTz STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'ttz_lambda_wrapper';
-- ./src/time_series/pipeline/lambda.rs:130:0
CREATE OR REPLACE FUNCTION toolkit_experimental."interval_lambda"("lambda" toolkit_experimental.Lambda, "time" TimestampTz, "value" double precision) RETURNS Interval STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'interval_lambda_wrapper';
-- ./src/time_series/pipeline/lambda.rs:148:0
CREATE OR REPLACE FUNCTION toolkit_experimental."point_lambda"("lambda" toolkit_experimental.Lambda, "time" TimestampTz, "value" double precision) RETURNS TABLE ("time" TimestampTz, "value" double precision) STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'point_lambda_wrapper';
-- ./src/time_series/pipeline/lambda.rs:171:0
CREATE OR REPLACE FUNCTION toolkit_experimental."trace_lambda"("lambda" toolkit_experimental.Lambda, "time" TimestampTz, "value" double precision) RETURNS SETOF text STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'trace_lambda_wrapper';



--
-- sql/time_series_pipeline_map.generated.sql
--
-- ./src/time_series/pipeline/map.rs:13:0
CREATE OR REPLACE FUNCTION toolkit_experimental.map("lambda" toolkit_experimental.Lambda) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'map_lambda_pipeline_element_wrapper';
-- ./src/time_series/pipeline/map.rs:126:0
CREATE OR REPLACE FUNCTION toolkit_experimental.map_series("function" regproc) RETURNS toolkit_experimental.UnstableTimevectorPipeline STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'map_series_pipeline_element_wrapper';
-- ./src/time_series/pipeline/map.rs:188:0
CREATE OR REPLACE FUNCTION toolkit_experimental.map_data("function" regproc) RETURNS toolkit_experimental.UnstableTimevectorPipeline STRICT STABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'map_data_pipeline_element_wrapper';



--
-- sql/time_series_pipeline_resample_to_rate.generated.sql
--
-- ./src/time_series/pipeline/resample_to_rate.rs:68:0
CREATE OR REPLACE FUNCTION toolkit_experimental.resample_to_rate("resample_method" text, "interval" Interval, "snap_to_rate" bool) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'resample_pipeline_element_wrapper';



--
-- sql/time_series_pipeline_sort.generated.sql
--
-- ./src/time_series/pipeline/sort.rs:7:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sort() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'sort_pipeline_element_wrapper';



--
-- sql/topn.generated.sql
--
-- ./src/topn.rs:24:0
CREATE OR REPLACE FUNCTION toolkit_experimental."topn_serialize"("state" internal) RETURNS bytea IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'topn_serialize_wrapper';
-- ./src/topn.rs:31:0
CREATE OR REPLACE FUNCTION toolkit_experimental."topn_deserialize"("bytes" bytea, "_internal" internal) RETURNS internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'topn_deserialize_wrapper';
CREATE TYPE toolkit_experimental.topn;
CREATE OR REPLACE FUNCTION toolkit_experimental.topn_in(cstring) RETURNS toolkit_experimental.topn IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'topn_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.topn_out(toolkit_experimental.topn) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'topn_out_wrapper';
CREATE TYPE toolkit_experimental.topn (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.topn_in,
                                OUTPUT = toolkit_experimental.topn_out,
                                STORAGE = extended
                            );
-- ./src/topn.rs:93:0
CREATE OR REPLACE FUNCTION toolkit_experimental."topn_trans"("state" internal, "size" int, "value" int) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'topn_trans_wrapper';
-- ./src/topn.rs:118:0
CREATE OR REPLACE FUNCTION toolkit_experimental."topn_combine"("state1" internal, "state2" internal) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'topn_combine_wrapper';
-- ./src/topn.rs:138:0
CREATE OR REPLACE FUNCTION toolkit_experimental."topn_final"("state" internal) RETURNS toolkit_experimental.TopN IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'topn_final_wrapper';
CREATE AGGREGATE toolkit_experimental.topn_agg(size int, value int)
(
    sfunc = toolkit_experimental.topn_trans,
    stype = internal,
    finalfunc = toolkit_experimental.topn_final,
    combinefunc = toolkit_experimental.topn_combine,
    serialfunc = toolkit_experimental.topn_serialize,
    deserialfunc = toolkit_experimental.topn_deserialize,
    parallel = safe
);
-- ./src/topn.rs:168:0
CREATE OR REPLACE FUNCTION toolkit_experimental."topn_compound_trans"("state" internal, "value" toolkit_experimental.TopN) RETURNS internal IMMUTABLE PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'topn_compound_trans_wrapper';
CREATE AGGREGATE toolkit_experimental.rollup(
    toolkit_experimental.topn
) (
    sfunc = toolkit_experimental.topn_compound_trans,
    stype = internal,
    finalfunc = toolkit_experimental.topn_final,
    combinefunc = toolkit_experimental.topn_combine,
    serialfunc = toolkit_experimental.topn_serialize,
    deserialfunc = toolkit_experimental.topn_deserialize,
    parallel = safe
);
-- ./src/topn.rs:201:0
CREATE OR REPLACE FUNCTION toolkit_experimental."num_vals"("agg" toolkit_experimental.TopN) RETURNS int IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'num_vals_wrapper';
-- ./src/topn.rs:219:0
CREATE OR REPLACE FUNCTION toolkit_experimental.topn("n" integer, "agg" toolkit_experimental.TopN) RETURNS TABLE ("value" bigint, "min_freq" double precision, "max_freq" double precision) IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'topn_iter_wrapper';
-- ./src/topn.rs:235:0
CREATE OR REPLACE FUNCTION toolkit_experimental."guaranteed_topn"("n" integer, "agg" toolkit_experimental.TopN) RETURNS bool IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'guaranteed_topn_wrapper';
-- ./src/topn.rs:254:0
CREATE OR REPLACE FUNCTION toolkit_experimental."max_ordered_n"("agg" toolkit_experimental.TopN) RETURNS int IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'max_ordered_n_wrapper';



--
-- sql/time_series_pipeline_arithmetic.generated.sql
--
-- ./src/time_series/pipeline/arithmetic.rs:69:0
CREATE OR REPLACE FUNCTION toolkit_experimental.add("rhs" double precision) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_add_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:81:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sub("rhs" double precision) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_sub_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:93:0
CREATE OR REPLACE FUNCTION toolkit_experimental.mul("rhs" double precision) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_mul_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:105:0
CREATE OR REPLACE FUNCTION toolkit_experimental.div("rhs" double precision) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_div_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:117:0
CREATE OR REPLACE FUNCTION toolkit_experimental.mod("rhs" double precision) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_mod_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:129:0
CREATE OR REPLACE FUNCTION toolkit_experimental.power("rhs" double precision) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_power_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:142:0
CREATE OR REPLACE FUNCTION toolkit_experimental.logN("rhs" double precision) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_log_n_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:158:0
CREATE OR REPLACE FUNCTION toolkit_experimental.abs() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_abs_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:169:0
CREATE OR REPLACE FUNCTION toolkit_experimental.cbrt() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_cbrt_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:180:0
CREATE OR REPLACE FUNCTION toolkit_experimental.ceil() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_ceil_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:191:0
CREATE OR REPLACE FUNCTION toolkit_experimental.floor() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_floor_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:202:0
CREATE OR REPLACE FUNCTION toolkit_experimental.ln() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_ln_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:213:0
CREATE OR REPLACE FUNCTION toolkit_experimental.log10() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_log10_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:224:0
CREATE OR REPLACE FUNCTION toolkit_experimental.round() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_round_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:236:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sign() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_sign_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:247:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sqrt() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_sqrt_wrapper';
-- ./src/time_series/pipeline/arithmetic.rs:258:0
CREATE OR REPLACE FUNCTION toolkit_experimental.trunc() RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_trunc_wrapper';



--
-- sql/time_series_pipeline_aggregation.generated.sql
--
CREATE TYPE toolkit_experimental.pipelinethenstatsagg;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenstatsagg_in(cstring) RETURNS toolkit_experimental.pipelinethenstatsagg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenstatsagg_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenstatsagg_out(toolkit_experimental.pipelinethenstatsagg) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenstatsagg_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethenstatsagg (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethenstatsagg_in,
                                OUTPUT = toolkit_experimental.pipelinethenstatsagg_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.pipelinethensum;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethensum_in(cstring) RETURNS toolkit_experimental.pipelinethensum IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethensum_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethensum_out(toolkit_experimental.pipelinethensum) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethensum_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethensum (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethensum_in,
                                OUTPUT = toolkit_experimental.pipelinethensum_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.pipelinethenaverage;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenaverage_in(cstring) RETURNS toolkit_experimental.pipelinethenaverage IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenaverage_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenaverage_out(toolkit_experimental.pipelinethenaverage) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenaverage_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethenaverage (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethenaverage_in,
                                OUTPUT = toolkit_experimental.pipelinethenaverage_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.pipelinethennumvals;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethennumvals_in(cstring) RETURNS toolkit_experimental.pipelinethennumvals IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethennumvals_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethennumvals_out(toolkit_experimental.pipelinethennumvals) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethennumvals_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethennumvals (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethennumvals_in,
                                OUTPUT = toolkit_experimental.pipelinethennumvals_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.pipelinethencounteragg;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethencounteragg_in(cstring) RETURNS toolkit_experimental.pipelinethencounteragg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethencounteragg_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethencounteragg_out(toolkit_experimental.pipelinethencounteragg) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethencounteragg_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethencounteragg (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethencounteragg_in,
                                OUTPUT = toolkit_experimental.pipelinethencounteragg_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.pipelinethenhyperloglog;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenhyperloglog_in(cstring) RETURNS toolkit_experimental.pipelinethenhyperloglog IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenhyperloglog_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenhyperloglog_out(toolkit_experimental.pipelinethenhyperloglog) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenhyperloglog_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethenhyperloglog (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethenhyperloglog_in,
                                OUTPUT = toolkit_experimental.pipelinethenhyperloglog_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.pipelinethenpercentileagg;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenpercentileagg_in(cstring) RETURNS toolkit_experimental.pipelinethenpercentileagg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenpercentileagg_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenpercentileagg_out(toolkit_experimental.pipelinethenpercentileagg) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenpercentileagg_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethenpercentileagg (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethenpercentileagg_in,
                                OUTPUT = toolkit_experimental.pipelinethenpercentileagg_out,
                                STORAGE = extended
                            );
-- ./src/time_series/pipeline/aggregation.rs:41:0
CREATE OR REPLACE FUNCTION "arrow_run_pipeline_then_stats_agg"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenStatsAgg) RETURNS StatsSummary1D IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_run_pipeline_then_stats_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:55:0
CREATE OR REPLACE FUNCTION toolkit_experimental."finalize_with_stats_agg"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_stats_agg" toolkit_experimental.PipelineThenStatsAgg) RETURNS toolkit_experimental.PipelineThenStatsAgg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'finalize_with_stats_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:80:0
CREATE OR REPLACE FUNCTION toolkit_experimental.stats_agg() RETURNS toolkit_experimental.PipelineThenStatsAgg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_stats_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:96:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_stats_agg_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_stats_agg_support_wrapper';
ALTER FUNCTION "arrow_run_pipeline_then_stats_agg" SUPPORT toolkit_experimental.pipeline_stats_agg_support;
-- ./src/time_series/pipeline/aggregation.rs:130:0
CREATE OR REPLACE FUNCTION toolkit_experimental.sum_cast("accessor" toolkit_experimental.AccessorSum) RETURNS toolkit_experimental.PipelineThenSum IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'sum_pipeline_element_wrapper';
    CREATE CAST (toolkit_experimental.AccessorSum AS toolkit_experimental.PipelineThenSum)
        WITH FUNCTION toolkit_experimental.sum_cast
        AS IMPLICIT;
-- ./src/time_series/pipeline/aggregation.rs:154:0
CREATE OR REPLACE FUNCTION "arrow_pipeline_then_sum"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenSum) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_pipeline_then_sum_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:171:0
CREATE OR REPLACE FUNCTION "finalize_with_sum"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_stats_agg" toolkit_experimental.PipelineThenSum) RETURNS toolkit_experimental.PipelineThenSum IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'finalize_with_sum_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:197:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_sum_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_sum_support_wrapper';
ALTER FUNCTION "arrow_pipeline_then_sum" SUPPORT toolkit_experimental.pipeline_sum_support;
-- ./src/time_series/pipeline/aggregation.rs:229:0
CREATE OR REPLACE FUNCTION toolkit_experimental.average_cast("accessor" toolkit_experimental.AccessorAverage) RETURNS toolkit_experimental.PipelineThenAverage IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'average_pipeline_element_wrapper';
    CREATE CAST (toolkit_experimental.AccessorAverage AS toolkit_experimental.PipelineThenAverage)
        WITH FUNCTION toolkit_experimental.average_cast
        AS IMPLICIT;
-- ./src/time_series/pipeline/aggregation.rs:253:0
CREATE OR REPLACE FUNCTION "arrow_pipeline_then_average"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenAverage) RETURNS double precision IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_pipeline_then_average_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:270:0
CREATE OR REPLACE FUNCTION "finalize_with_average"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_stats_agg" toolkit_experimental.PipelineThenAverage) RETURNS toolkit_experimental.PipelineThenAverage IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'finalize_with_average_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:296:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_average_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_average_support_wrapper';
ALTER FUNCTION "arrow_pipeline_then_average" SUPPORT toolkit_experimental.pipeline_average_support;
-- ./src/time_series/pipeline/aggregation.rs:328:0
CREATE OR REPLACE FUNCTION toolkit_experimental.num_vals_cast("accessor" toolkit_experimental.AccessorNumVals) RETURNS toolkit_experimental.PipelineThenNumVals IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'num_vals_pipeline_element_wrapper';
    CREATE CAST (toolkit_experimental.AccessorNumVals AS toolkit_experimental.PipelineThenNumVals)
        WITH FUNCTION toolkit_experimental.num_vals_cast
        AS IMPLICIT;
-- ./src/time_series/pipeline/aggregation.rs:352:0
CREATE OR REPLACE FUNCTION "arrow_pipeline_then_num_vals"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenNumVals) RETURNS bigint IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_pipeline_then_num_vals_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:362:0
CREATE OR REPLACE FUNCTION "finalize_with_num_vals"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_stats_agg" toolkit_experimental.PipelineThenNumVals) RETURNS toolkit_experimental.PipelineThenNumVals IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'finalize_with_num_vals_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:388:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_num_vals_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_num_vals_support_wrapper';
ALTER FUNCTION "arrow_pipeline_then_num_vals" SUPPORT toolkit_experimental.pipeline_num_vals_support;
-- ./src/time_series/pipeline/aggregation.rs:416:0
CREATE OR REPLACE FUNCTION "arrow_run_pipeline_then_counter_agg"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenCounterAgg) RETURNS CounterSummary IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_run_pipeline_then_counter_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:434:0
CREATE OR REPLACE FUNCTION toolkit_experimental."finalize_with_counter_agg"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_counter_agg" toolkit_experimental.PipelineThenCounterAgg) RETURNS toolkit_experimental.PipelineThenCounterAgg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'finalize_with_counter_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:459:0
CREATE OR REPLACE FUNCTION toolkit_experimental.counter_agg() RETURNS toolkit_experimental.PipelineThenCounterAgg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_counter_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:474:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_counter_agg_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_counter_agg_support_wrapper';
ALTER FUNCTION "arrow_run_pipeline_then_counter_agg" SUPPORT toolkit_experimental.pipeline_counter_agg_support;
-- ./src/time_series/pipeline/aggregation.rs:506:0
CREATE OR REPLACE FUNCTION "arrow_run_pipeline_then_hyperloglog"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenHyperLogLog) RETURNS HyperLogLog IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_run_pipeline_then_hyperloglog_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:520:0
CREATE OR REPLACE FUNCTION toolkit_experimental."finalize_with_hyperloglog"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_hyperloglog" toolkit_experimental.PipelineThenHyperLogLog) RETURNS toolkit_experimental.PipelineThenHyperLogLog IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'finalize_with_hyperloglog_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:547:0
CREATE OR REPLACE FUNCTION toolkit_experimental.hyperloglog("size" integer) RETURNS toolkit_experimental.PipelineThenHyperLogLog IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_hyperloglog_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:563:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_hyperloglog_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_hyperloglog_support_wrapper';
ALTER FUNCTION "arrow_run_pipeline_then_hyperloglog" SUPPORT toolkit_experimental.pipeline_hyperloglog_support;
-- ./src/time_series/pipeline/aggregation.rs:594:0
CREATE OR REPLACE FUNCTION "arrow_run_pipeline_then_percentile_agg"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenPercentileAgg) RETURNS UddSketch IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_run_pipeline_then_percentile_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:604:0
CREATE OR REPLACE FUNCTION toolkit_experimental."finalize_with_percentile_agg"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_hyperloglog" toolkit_experimental.PipelineThenPercentileAgg) RETURNS toolkit_experimental.PipelineThenPercentileAgg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'finalize_with_percentile_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:629:0
CREATE OR REPLACE FUNCTION toolkit_experimental.percentile_agg() RETURNS toolkit_experimental.PipelineThenPercentileAgg IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_percentile_agg_wrapper';
-- ./src/time_series/pipeline/aggregation.rs:644:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_percentile_agg_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_percentile_agg_support_wrapper';
ALTER FUNCTION "arrow_run_pipeline_then_percentile_agg" SUPPORT toolkit_experimental.pipeline_percentile_agg_support;
CREATE OPERATOR -> (
   PROCEDURE="arrow_run_pipeline_then_stats_agg",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenStatsAgg
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_pipeline_then_sum",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenSum
);
CREATE OPERATOR -> (
   PROCEDURE="finalize_with_sum",
   LEFTARG=toolkit_experimental.UnstableTimevectorPipeline,
   RIGHTARG=toolkit_experimental.PipelineThenSum
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_pipeline_then_average",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenAverage
);
CREATE OPERATOR -> (
   PROCEDURE="finalize_with_average",
   LEFTARG=toolkit_experimental.UnstableTimevectorPipeline,
   RIGHTARG=toolkit_experimental.PipelineThenAverage
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_pipeline_then_num_vals",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenNumVals
);
CREATE OPERATOR -> (
   PROCEDURE="finalize_with_num_vals",
   LEFTARG=toolkit_experimental.UnstableTimevectorPipeline,
   RIGHTARG=toolkit_experimental.PipelineThenNumVals
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_run_pipeline_then_counter_agg",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenCounterAgg
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_run_pipeline_then_hyperloglog",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenHyperLogLog
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_run_pipeline_then_percentile_agg",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenPercentileAgg
);



--
-- sql/zz_triggers.generated.sql
--
-- ./src/zz_triggers.rs:5:0
CREATE OR REPLACE FUNCTION "timescaledb_toolkit_probe"() RETURNS void STRICT LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'timescaledb_toolkit_probe_wrapper';
CREATE OR REPLACE FUNCTION disallow_experimental_dependencies()
  RETURNS event_trigger
 LANGUAGE plpgsql
  AS $$
DECLARE
  guc_set TEXT;
  experimental_schema_id oid;
BEGIN

  guc_set := current_setting('timescaledb_toolkit_acknowledge_auto_drop', true);
  IF guc_set IS NOT NULL AND guc_set = 'on' THEN
    RETURN;
  END IF;

  SELECT oid schema_oid
  INTO experimental_schema_id
  FROM pg_catalog.pg_namespace
  WHERE nspname='toolkit_experimental'
  LIMIT 1;

  IF EXISTS (
    SELECT top_dep.objid, top_dep.deptype, top_dep.refobjid
    FROM pg_catalog.pg_depend top_dep
    WHERE top_dep.refobjid=experimental_schema_id
    AND top_dep.objid IN (
      SELECT depend.refobjid dep_id
      FROM pg_catalog.pg_depend depend
      INNER JOIN (
        SELECT obj.objid id
        FROM pg_event_trigger_ddl_commands() as obj
        WHERE NOT obj.in_extension
      ) created ON created.id = depend.objid))
  THEN
    PERFORM timescaledb_toolkit_probe();
    RAISE EXCEPTION 'features in toolkit_experimental are unstable, and objects depending on them will be deleted on extension update (there will be a DROP SCHEMA toolkit_experimental CASCADE), which on Forge can happen at any time.'
      USING DETAIL='If you really want to do this, and are willing to accept the possibility that objects so created may be deleted without warning, set timescaledb_toolkit_acknowledge_auto_drop to ''true''.';
  END IF;
END;
$$;

CREATE OR REPLACE FUNCTION disallow_experimental_view_dependencies()
RETURNS event_trigger
LANGUAGE plpgsql
AS $$
DECLARE
  guc_set TEXT;
  experimental_schema_id oid;
BEGIN

  guc_set := current_setting('timescaledb_toolkit_acknowledge_auto_drop', true);
  IF guc_set IS NOT NULL AND guc_set = 'on' THEN
    RETURN;
  END IF;

  SELECT oid schema_oid
  INTO experimental_schema_id
  FROM pg_catalog.pg_namespace
  WHERE nspname='toolkit_experimental'
  LIMIT 1;

  -- views do not depend directly on objects, instead the rewrite rule depends
  -- on both the view, and the dependencies, so check for that
  IF EXISTS (
    SELECT top_dep.objid, top_dep.deptype, top_dep.refobjid
    FROM pg_catalog.pg_depend top_dep
    WHERE top_dep.refobjid=experimental_schema_id
    AND top_dep.objid IN (
      SELECT depend2.refobjid dep_id
      FROM pg_catalog.pg_depend depend
      INNER JOIN (
        SELECT obj.objid id
        FROM pg_event_trigger_ddl_commands() as obj
        WHERE NOT obj.in_extension
      ) created ON created.id = depend.refobjid
      INNER JOIN pg_catalog.pg_depend depend2 ON depend2.objid = depend.objid)
    )
  THEN
    PERFORM timescaledb_toolkit_probe();
    RAISE EXCEPTION 'features in toolkit_experimental are unstable, and objects depending on them will be deleted on extension update (there will be a DROP SCHEMA toolkit_experimental CASCADE), which on Forge can happen at any time.'
        USING DETAIL='If you really want to do this, and are willing to accept the possibility that objects so created may be deleted without warning, set timescaledb_toolkit_acknowledge_auto_drop to ''true''.';
  END IF;
END;
$$;

CREATE EVENT TRIGGER disallow_experimental_deps ON ddl_command_end
  WHEN tag IN ('CREATE AGGREGATE', 'CREATE CAST',
    'CREATE FUNCTION', 'CREATE INDEX', 'CREATE MATERIALIZED VIEW',
    'CREATE OPERATOR', 'CREATE PROCEDURE', 'CREATE TABLE', 'CREATE TABLE AS',
    'CREATE TRIGGER', 'CREATE TYPE', 'CREATE VIEW')
  EXECUTE FUNCTION disallow_experimental_dependencies();

CREATE EVENT TRIGGER disallow_experimental_dependencies_on_views ON ddl_command_end
  WHEN tag IN ('CREATE MATERIALIZED VIEW', 'CREATE VIEW')
  EXECUTE FUNCTION disallow_experimental_view_dependencies();



--
-- sql/time_series_pipeline_expansion.generated.sql
--
CREATE TYPE toolkit_experimental.pipelinethenunnest;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenunnest_in(cstring) RETURNS toolkit_experimental.pipelinethenunnest IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenunnest_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelinethenunnest_out(toolkit_experimental.pipelinethenunnest) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelinethenunnest_out_wrapper';
CREATE TYPE toolkit_experimental.pipelinethenunnest (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelinethenunnest_in,
                                OUTPUT = toolkit_experimental.pipelinethenunnest_out,
                                STORAGE = extended
                            );
CREATE TYPE toolkit_experimental.pipelineforcematerialize;
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelineforcematerialize_in(cstring) RETURNS toolkit_experimental.pipelineforcematerialize IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelineforcematerialize_in_wrapper';
CREATE OR REPLACE FUNCTION toolkit_experimental.pipelineforcematerialize_out(toolkit_experimental.pipelineforcematerialize) RETURNS cstring IMMUTABLE STRICT PARALLEL SAFE LANGUAGE C AS '$libdir/timescaledb_toolkit-1.3', 'pipelineforcematerialize_out_wrapper';
CREATE TYPE toolkit_experimental.pipelineforcematerialize (
                                INTERNALLENGTH = variable,
                                INPUT = toolkit_experimental.pipelineforcematerialize_in,
                                OUTPUT = toolkit_experimental.pipelineforcematerialize_out,
                                STORAGE = extended
                            );
-- ./src/time_series/pipeline/expansion.rs:30:0
CREATE OR REPLACE FUNCTION toolkit_experimental.unnest() RETURNS toolkit_experimental.PipelineThenUnnest IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_unnest_wrapper';
-- ./src/time_series/pipeline/expansion.rs:45:0
CREATE OR REPLACE FUNCTION "arrow_finalize_with_unnest"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_stats_agg" toolkit_experimental.PipelineThenUnnest) RETURNS toolkit_experimental.PipelineThenUnnest IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_finalize_with_unnest_wrapper';
-- ./src/time_series/pipeline/expansion.rs:72:0
CREATE OR REPLACE FUNCTION "arrow_run_pipeline_then_unnest"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineThenUnnest) RETURNS TABLE ("time" TimestampTz, "value" double precision) IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_run_pipeline_then_unnest_wrapper';
-- ./src/time_series/pipeline/expansion.rs:94:0
CREATE OR REPLACE FUNCTION toolkit_experimental.materialize() RETURNS toolkit_experimental.PipelineForceMaterialize IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_series_wrapper';
-- ./src/time_series/pipeline/expansion.rs:109:0
CREATE OR REPLACE FUNCTION "arrow_force_materialize"("pipeline" toolkit_experimental.UnstableTimevectorPipeline, "then_stats_agg" toolkit_experimental.PipelineForceMaterialize) RETURNS toolkit_experimental.PipelineForceMaterialize IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_force_materialize_wrapper';
-- ./src/time_series/pipeline/expansion.rs:135:0
CREATE OR REPLACE FUNCTION "arrow_run_pipeline_then_materialize"("timevector" toolkit_experimental.Timevector, "pipeline" toolkit_experimental.PipelineForceMaterialize) RETURNS toolkit_experimental.Timevector IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'arrow_run_pipeline_then_materialize_wrapper';
-- ./src/time_series/pipeline/expansion.rs:147:0
CREATE OR REPLACE FUNCTION toolkit_experimental."pipeline_materialize_support"("input" Internal) RETURNS Internal IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'pipeline_materialize_support_wrapper';
ALTER FUNCTION "arrow_run_pipeline_then_materialize" SUPPORT toolkit_experimental.pipeline_materialize_support;
CREATE OPERATOR -> (
   PROCEDURE="arrow_finalize_with_unnest",
   LEFTARG=toolkit_experimental.UnstableTimevectorPipeline,
   RIGHTARG=toolkit_experimental.PipelineThenUnnest
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_run_pipeline_then_unnest",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineThenUnnest
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_force_materialize",
   LEFTARG=toolkit_experimental.UnstableTimevectorPipeline,
   RIGHTARG=toolkit_experimental.PipelineForceMaterialize
);
CREATE OPERATOR -> (
   PROCEDURE="arrow_run_pipeline_then_materialize",
   LEFTARG=toolkit_experimental.Timevector,
   RIGHTARG=toolkit_experimental.PipelineForceMaterialize
);



--
-- sql/time_series_pipeline_fill_to.generated.sql
--
-- ./src/time_series/pipeline/fill_to.rs:42:0
CREATE OR REPLACE FUNCTION toolkit_experimental.fill_to("interval" Interval, "fill_method" text) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'fillto_pipeline_element_wrapper';



--
-- sql/time_series_pipeline_filter.generated.sql
--
-- ./src/time_series/pipeline/filter.rs:7:0
CREATE OR REPLACE FUNCTION toolkit_experimental.filter("lambda" toolkit_experimental.Lambda) RETURNS toolkit_experimental.UnstableTimevectorPipeline IMMUTABLE STRICT PARALLEL SAFE LANGUAGE c AS '$libdir/timescaledb_toolkit-1.3', 'filter_lambda_pipeline_element_wrapper';



